SystemOrganization addCategory: #'PetitSmalltalk-Core'!
SystemOrganization addCategory: #'PetitSmalltalk-Tests'!

PPToken subclass: #PPSmalltalkToken
	instanceVariableNames: 'comments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitSmalltalk-Core'!

!PPSmalltalkToken methodsFor: 'accessing' stamp: 'lr 12/7/2009 09:30'!
comments
	^ comments! !

!PPSmalltalkToken methodsFor: 'accessing' stamp: 'lr 12/7/2009 09:30'!
comments: anArray
	comments := anArray! !

!PPSmalltalkToken methodsFor: 'compatiblity' stamp: 'lr 2/14/2010 11:58'!
length
	^ self size! !

!RBProgramNode methodsFor: '*petitsmalltalk-accessing' stamp: 'lr 1/29/2010 12:02'!
addComments: aCollectionOfIntervals
	(aCollectionOfIntervals isNil or: [ aCollectionOfIntervals isEmpty ])
		ifFalse: [ self comments: self comments , aCollectionOfIntervals ]! !

!PPParser methodsFor: '*petitsmalltalk-operations' stamp: 'lr 6/29/2010 14:27'!
smalltalkToken
	^ PPSmalltalkTokenParser on: self! !

TestCase subclass: #PPSmalltalkNumberMakerTest
	instanceVariableNames: 'epsilon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitSmalltalk-Tests'!

!PPSmalltalkNumberMakerTest methodsFor: 'accessing' stamp: 'fbs 9/7/2011 07:49'!
assert: expectedNumber equals: actualNumber withTolerance: aNumber
	self assert: (expectedNumber - actualNumber) abs < aNumber.! !

!PPSmalltalkNumberMakerTest methodsFor: 'testing' stamp: 'fbs 9/5/2011 21:23'!
testMakeInteger
	| mkInt |
	mkInt := [:i | PPSmalltalkNumberMaker integerPart: i].
	self assert: 0 equals: (mkInt value: '0') makeNumber.
	self assert: 1 equals: (mkInt value: '1') makeNumber.
	self assert: 98765432109876543210 equals: (mkInt value: '98765432109876543210') makeNumber.! !

!PPSmalltalkNumberMakerTest methodsFor: 'testing' stamp: 'fbs 9/6/2011 17:59'!
testMakeIntegerWithExponent
	| m |
	m := PPSmalltalkNumberMaker.
	self assert: 0 equals: (m integerPart: '0' exponent: '0') makeNumber.
	self assert: 0 equals: (m integerPart: '0' exponent: '1') makeNumber.
	self assert: 1 equals: (m integerPart: '1' exponent: '0') makeNumber.
	self assert: 10 equals: (m integerPart: '1' exponent: '1') makeNumber.
	self assert: 1000 equals: (m integerPart: '1' exponent: '3') makeNumber.
	self assert: (10 raisedTo: 40) equals: (m integerPart: '1' exponent: '40') makeNumber.! !

!PPSmalltalkNumberMakerTest methodsFor: 'testing' stamp: 'fbs 9/8/2011 08:12'!
testMakeIntegerWithExponentAndBase
	| m |
	m := (PPSmalltalkNumberMaker integerPart: '1' exponent: '10') withBase: 4.
	self assert: 4r1e10 equals: m makeNumber.! !

!PPSmalltalkNumberMakerTest methodsFor: 'testing' stamp: 'fbs 9/7/2011 17:43'!
testMakeMantissa
	| mkFloat |
	mkFloat := [:i :f | PPSmalltalkNumberMaker integerPart: i fractionalPart: f].
	self assert: 0 equals: (mkFloat value: '0' value: '0') makeMantissa.
	self assert: 1.0 equals: (mkFloat value: '1' value: '0') makeMantissa.
	self assert: 1/10 equals: (mkFloat value: '0' value: '1') makeMantissa.
	self assert: (100 + (1/1000)) equals: (mkFloat value: '100' value: '001') makeMantissa.! !

!PPSmalltalkNumberMakerTest methodsFor: 'testing' stamp: 'fbs 9/5/2011 21:49'!
testMakeMantissaWithBase
	| mkFloat |
	mkFloat := [:i :f | PPSmalltalkNumberMaker base: 8 integerPart: i fractionalPart: f].
	self assert: 0 equals: (mkFloat value: '0' value: '0') makeNumber.
	self assert: 1.0 equals: (mkFloat value: '1' value: '0') makeNumber.
	self assert: 0.125 equals: (mkFloat value: '0' value: '1') makeNumber.
	self assert: 64.001953125 equals: (mkFloat value: '100' value: '001') makeNumber.! !

!PPSmalltalkNumberMakerTest methodsFor: 'testing' stamp: 'fbs 9/6/2011 12:35'!
testMakeMantissaWithBaseWithExponent
	| mkFloat |
	mkFloat := [:i :f :e | PPSmalltalkNumberMaker base: 8 integerPart: i fractionalPart: f exponent: e].
	self assert: 0.0 equals: (mkFloat value: '0' value: '0' value: '0') makeNumber.
	self assert: 0.0 equals: (mkFloat value: '0' value: '0' value: '10') makeNumber.
	self assert: 8.0 equals: (mkFloat value: '1' value: '0' value: '1') makeNumber.
	self assert: 64.0 equals: (mkFloat value: '1' value: '0' value: '2') makeNumber.
	self assert: 8.0 equals: (mkFloat value: '0' value: '1' value: '2') makeNumber.
	self assert: 1.073774592e9 equals: (mkFloat value: '100' value: '001' value: '8') makeNumber.! !

!PPSmalltalkNumberMakerTest methodsFor: 'testing' stamp: 'fbs 9/6/2011 12:45'!
testMakeMantissaWithBaseWithSignedExponent
	| mkFloat |
	mkFloat := [:i :f :e | PPSmalltalkNumberMaker base: 8 integerPart: i fractionalPart: f exponentSign: '-' exponent: e].
	self assert: 8r0.0e-0 equals: (mkFloat value: '0' value: '0' value: '0') makeNumber.
	self assert: 8r0.0e-10 equals: (mkFloat value: '0' value: '0' value: '10') makeNumber.
	self assert: 8r1.0e-1 equals: (mkFloat value: '1' value: '0' value: '1') makeNumber.
	self assert: 8r1.0e-2 equals: (mkFloat value: '1' value: '0' value: '2') makeNumber.
	self assert: 8r0.1e-2 equals: (mkFloat value: '0' value: '1' value: '2') makeNumber.
	self assert: 8r1.001e-8 equals: (mkFloat value: '1' value: '001' value: '8') makeNumber.! !

!PPSmalltalkNumberMakerTest methodsFor: 'testing' stamp: 'fbs 9/7/2011 17:41'!
testMakeScaledDecimal
	| mkScale |
	mkScale := [:i :f :s | PPSmalltalkNumberMaker integerPart: i fractionalPart: f scale: s].
	self assert: 0.0s0 equals: (mkScale value: '0' value: '0' value: '0') makeNumber.
	self assert: 1.0s0 equals: (mkScale value: '1' value: '0' value: '0') makeNumber.
	self assert: 0.1s0 equals: (mkScale value: '0' value: '1' value: '0') makeNumber withTolerance: 1e-6.
	self assert: 0.1s1 equals: (mkScale value: '0' value: '1' value: '1') makeNumber withTolerance: 1e-6.
	self assert: 0.0s1 equals: (mkScale value: '0' value: '0' value: '1') makeNumber.
	self assert: 9.12s2 equals: (mkScale value: '9' value: '123' value: '2') makeNumber withTolerance: 9e-3. "something a bit less than 0.001"! !

!PPSmalltalkNumberMakerTest methodsFor: 'testing' stamp: 'fbs 9/5/2011 07:43'!
testMakeSignedInteger
	self assert: 0 equals: (PPSmalltalkNumberMaker makeSigned: '-' integer: '0').
	self assert: -1 equals: (PPSmalltalkNumberMaker makeSigned: '-' integer: '1').
	self assert: -98765432109876543210 equals: (PPSmalltalkNumberMaker makeSigned: '-' integer: '98765432109876543210').! !

!PPSmalltalkNumberMakerTest methodsFor: 'testing' stamp: 'fbs 9/6/2011 17:48'!
testMakeSignedIntegerWithArbitraryBase
	| mkInt |
	mkInt := [:d :s | PPSmalltalkNumberMaker base: 16 sign: s integerPart: d fractionalPart: '' exponentSign: '' exponent: ''].
	self assert: 0 equals: (mkInt value: '0' value: '') makeInteger.
	self assert: -1 equals: (mkInt value: '1' value: '-') makeInteger.
	self assert: 3735928559 equals: (mkInt value: 'deadbeef' value: '') makeInteger.! !

!PPSmalltalkNumberMakerTest methodsFor: 'testing - copying' stamp: 'fbs 9/7/2011 07:54'!
testWithBaseReturnsMutatedCopy
	| orig copy |
	orig := PPSmalltalkNumberMaker base: 9 sign: '-' integerPart: '1' fractionalPart: '2' exponentSign: '-' exponent: '3'.
	copy := orig withBase: 10.
	self assert: 10r-1.2e-3 equals: copy makeNumber.! !

!PPSmalltalkNumberMakerTest methodsFor: 'testing - copying' stamp: 'fbs 9/7/2011 07:55'!
testWithExponentReturnsMutatedCopy
	| orig copy |
	orig := PPSmalltalkNumberMaker base: 9 sign: '-' integerPart: '1' fractionalPart: '2' exponentSign: '-' exponent: '3'.
	copy := orig withExponent: '4'.
	self assert: 9r1.2e-4 equals: copy makeNumber withTolerance: 9r0.00001.! !

!PPSmalltalkNumberMakerTest methodsFor: 'testing - copying' stamp: 'fbs 9/7/2011 21:24'!
testWithFractionalPartReturnsMutatedCopy
	| orig copy |
	orig := PPSmalltalkNumberMaker base: 9 sign: '-' integerPart: '1' fractionalPart: '2' exponentSign: '-' exponent: '3'.
	copy := orig withFractionalPart: '4'.
	self assert: 9r-1.4e-3 equals: copy makeNumber.! !

!PPSmalltalkNumberMakerTest methodsFor: 'testing - copying' stamp: 'fbs 9/7/2011 07:54'!
testWithScaleReturnsMutatedCopy
	| orig copy |
	orig := PPSmalltalkNumberMaker base: 9 sign: '-' integerPart: '1' fractionalPart: '2' exponentSign: '-' exponent: '3'.
	copy := orig withScale: '4'.
	self assert: 9r-1.2s4 equals: copy makeNumber withTolerance: 9r0.00001.! !

!PPSmalltalkNumberMakerTest methodsFor: 'testing - copying' stamp: 'fbs 9/7/2011 07:56'!
testWithScaleReturnsRepresentationOfScaledDecimal
	| orig |
	orig := PPSmalltalkNumberMaker base: 9 sign: '-' integerPart: '1' fractionalPart: '2' exponentSign: '-' exponent: '3'.
	self assert: (orig withScale: '2') makeNumber isScaledDecimal.! !

!PPSmalltalkNumberMakerTest methodsFor: 'testing - copying' stamp: 'fbs 9/7/2011 21:51'!
testWithSignReturnsMutatedCopy
	| orig copy |
	orig := PPSmalltalkNumberMaker base: 9 integerPart: '1' fractionalPart: '2' exponentSign: '-' exponent: '3'.
	copy := orig withSign: '-'.
	self assert: 9r-1.2e-3 equals: copy makeNumber.! !

Object subclass: #PPSmalltalkNumberMaker
	instanceVariableNames: 'sign integerPart fractionalPart exponent scale base exponentSign'
	classVariableNames: 'NotPresent'
	poolDictionaries: ''
	category: 'PetitSmalltalk-Core'!

!PPSmalltalkNumberMaker class methodsFor: 'instance creation' stamp: 'fbs 9/5/2011 21:35'!
base: baseInteger integerPart: integerPartString fractionalPart: fractionalPartString
	^ self
		base: baseInteger
		sign: NotPresent
		integerPart: integerPartString
		fractionalPart: fractionalPartString
		exponentSign: NotPresent
		exponent: NotPresent
		scale: NotPresent.! !

!PPSmalltalkNumberMaker class methodsFor: 'instance creation' stamp: 'fbs 9/6/2011 09:41'!
base: baseInteger integerPart: integerPartString fractionalPart: fractionalPartString exponent: exponentString
	^ self
		base: baseInteger
		sign: NotPresent
		integerPart: integerPartString
		fractionalPart: fractionalPartString
		exponentSign: NotPresent
		exponent: exponentString
		scale: NotPresent.! !

!PPSmalltalkNumberMaker class methodsFor: 'instance creation' stamp: 'fbs 9/6/2011 09:41'!
base: baseInteger integerPart: integerPartString fractionalPart: fractionalPartString exponentSign: exponentSignString exponent: exponentString
	^ self
		base: baseInteger
		sign: NotPresent
		integerPart: integerPartString
		fractionalPart: fractionalPartString
		exponentSign: exponentSignString
		exponent: exponentString
		scale: NotPresent.! !

!PPSmalltalkNumberMaker class methodsFor: 'instance creation' stamp: 'fbs 9/6/2011 17:30'!
base: baseInteger integerPart: integerPartString fractionalPart: fractionalPartString scale: scaleString
	^ self
		base: baseInteger
		sign: NotPresent
		integerPart: integerPartString
		fractionalPart: fractionalPartString
		exponentSign: NotPresent
		exponent: NotPresent
		scale: NotPresent.! !

!PPSmalltalkNumberMaker class methodsFor: 'instance creation' stamp: 'fbs 9/5/2011 21:35'!
base: baseInteger sign: signString integerPart: integerPartString fractionalPart: fractionalPartString
	^ self
		base: baseInteger
		sign: signString
		integerPart: integerPartString
		fractionalPart: fractionalPartString
		exponentSign: NotPresent
		exponent: NotPresent
		scale: NotPresent.! !

!PPSmalltalkNumberMaker class methodsFor: 'private' stamp: 'fbs 9/6/2011 17:52'!
base: baseInteger sign: signString integerPart: integerPartString fractionalPart: fractionalPartString exponentSign: exponentSignString exponent: exponentString
	^ self new
		base: baseInteger
		sign: signString
		integerPart: integerPartString
		fractionalPart: fractionalPartString
		exponentSign: exponentSignString
		exponent: exponentString
		scale: NotPresent.! !

!PPSmalltalkNumberMaker class methodsFor: 'private' stamp: 'fbs 9/5/2011 13:00'!
base: baseInteger sign: signString integerPart: integerPartString fractionalPart: fractionalPartString exponentSign: exponentSignString exponent: exponentString scale: scaleString
	^ self new
		base: baseInteger
		sign: signString
		integerPart: integerPartString
		fractionalPart: fractionalPartString
		exponentSign: exponentSignString
		exponent: exponentString
		scale: scaleString.! !

!PPSmalltalkNumberMaker class methodsFor: 'private' stamp: 'fbs 9/7/2011 07:57'!
base: baseInteger sign: signString integerPart: integerPartString fractionalPart: fractionalPartString scale: scaleString
	^ self new
		base: baseInteger
		sign: signString
		integerPart: integerPartString
		fractionalPart: fractionalPartString
		exponentSign: NotPresent
		exponent: NotPresent
		scale: scaleString.! !

!PPSmalltalkNumberMaker class methodsFor: 'class initialization' stamp: 'fbs 9/5/2011 07:30'!
initialize
	"A sentinel used to indicate something missing. We don't use nil because using nil is a bad idea. Or, rather, NOT using nil allows us to catch nil references caused by other parts: we know it's not _our_ fault."
	NotPresent := Object new.! !

!PPSmalltalkNumberMaker class methodsFor: 'instance creation' stamp: 'fbs 9/5/2011 21:35'!
integerPart: integerPart
	^ self
		base: 10
		sign: NotPresent
		integerPart: integerPart
		fractionalPart: NotPresent
		exponentSign: NotPresent
		exponent: NotPresent
		scale: NotPresent.! !

!PPSmalltalkNumberMaker class methodsFor: 'instance creation' stamp: 'fbs 9/5/2011 12:57'!
integerPart: integerPartString exponent: exponentString
	^ self
		base: 10
		sign: NotPresent
		integerPart: integerPartString
		fractionalPart: NotPresent
		exponentSign: NotPresent
		exponent: exponentString
		scale: NotPresent.! !

!PPSmalltalkNumberMaker class methodsFor: 'instance creation' stamp: 'fbs 9/5/2011 21:30'!
integerPart: integerString fractionalPart: fractionString
	^ self
		base: 10
		sign: NotPresent
		integerPart: integerString
		fractionalPart: fractionString
		exponentSign: NotPresent
		exponent: NotPresent
		scale: NotPresent.! !

!PPSmalltalkNumberMaker class methodsFor: 'instance creation' stamp: 'fbs 9/7/2011 08:04'!
integerPart: integerPartString fractionalPart: fractionalPartString scale: scaleString
	^ self
		base: 10
		sign: NotPresent
		integerPart: integerPartString
		fractionalPart: fractionalPartString
		exponentSign: NotPresent
		exponent: NotPresent
		scale: scaleString.! !

!PPSmalltalkNumberMaker class methodsFor: 'instance creation' stamp: 'fbs 9/5/2011 07:38'!
makeInteger: someDigits
	^ (self integerPart: someDigits) makeInteger.! !

!PPSmalltalkNumberMaker class methodsFor: 'instance creation' stamp: 'fbs 9/5/2011 07:43'!
makeSigned: signString integer: someDigits
	^ (self sign: signString
		integerPart: someDigits) makeInteger.! !

!PPSmalltalkNumberMaker class methodsFor: 'instance creation' stamp: 'fbs 9/5/2011 12:57'!
sign: signString integerPart: integerPartString
	^ self
		base: 10
		sign: signString
		integerPart: integerPartString
		fractionalPart: NotPresent
		exponentSign: NotPresent
		exponent: NotPresent
		scale: NotPresent.! !

!PPSmalltalkNumberMaker methodsFor: 'initialize-release' stamp: 'fbs 9/5/2011 08:06'!
base: anInteger sign: signString integerPart: integerPartString fractionalPart: fractionalPartString exponentSign: exponentSignString exponent: exponentString scale: scaleString
	base := anInteger.
	sign := signString.
	integerPart := integerPartString.
	fractionalPart := fractionalPartString.
	exponentSign := exponentSignString.
	exponent := exponentString.
	scale := scaleString.! !

!PPSmalltalkNumberMaker methodsFor: 'initialize-release' stamp: 'fbs 9/6/2011 17:31'!
initialize
	base := NotPresent.
	sign := NotPresent.
	integerPart := NotPresent.
	fractionalPart := NotPresent.
	exponentSign := NotPresent.
	exponent := NotPresent.
	scale := NotPresent.! !

!PPSmalltalkNumberMaker methodsFor: 'private' stamp: 'fbs 9/14/2011 07:54'!
makeInteger
	| value |
	value := self toInteger: integerPart.
	
	(sign = '-')
		ifTrue: [value := value negated].
	
	^ value.! !

!PPSmalltalkNumberMaker methodsFor: 'private' stamp: 'fbs 9/7/2011 17:42'!
makeMantissa
	| baseValue int frac |
	int := self toInteger: integerPart.
	frac := self toInteger: fractionalPart.
	baseValue := int + (frac / (base raisedTo: fractionalPart size)).
	
	(sign = '-')
		ifTrue: [baseValue := baseValue negated].
		
	^ baseValue.! !

!PPSmalltalkNumberMaker methodsFor: 'evaluating' stamp: 'fbs 9/8/2011 08:14'!
makeNumber
	| baseValue |
	baseValue := (fractionalPart = NotPresent)
		ifTrue: [self makeInteger]
		ifFalse: [self makeMantissa].
	
	(scale = NotPresent)
		ifFalse: [^ ScaledDecimal newFromNumber: baseValue scale: (self toInteger: scale)].
		
	baseValue := self raised: baseValue.
	(fractionalPart = NotPresent)
		ifFalse: [^ baseValue asFloat].

	^ baseValue.! !

!PPSmalltalkNumberMaker methodsFor: 'private' stamp: 'fbs 9/8/2011 08:15'!
raised: baseValue
	| exp |
	(exponent = NotPresent)
		ifTrue: [^ baseValue].
	(baseValue isZero)
		ifTrue: [^ baseValue "0e0 = 0, while 0 raisedTo: 0 = 1"].
		
	exp := self toInteger: exponent base: 10.
	(exponentSign = '-')
		ifTrue: [exp := exp negated].
		
	^ baseValue * (base raisedTo: exp).! !

!PPSmalltalkNumberMaker methodsFor: 'converting' stamp: 'fbs 9/8/2011 08:15'!
toInteger: someDigits
	^ self toInteger: someDigits base: base.! !

!PPSmalltalkNumberMaker methodsFor: 'converting' stamp: 'fbs 9/8/2011 08:15'!
toInteger: someDigits base: radix
	^ someDigits inject: 0 into: [:acc :each | radix * acc + each digitValue].! !

!PPSmalltalkNumberMaker methodsFor: 'copying' stamp: 'fbs 9/5/2011 08:06'!
withBase: aString
	^ self class
	      base: aString
		sign: sign
		integerPart: integerPart
		fractionalPart: fractionalPart
		exponentSign: exponentSign
		exponent: exponent
		scale: scale! !

!PPSmalltalkNumberMaker methodsFor: 'copying' stamp: 'fbs 9/7/2011 07:58'!
withExponent: aString
	^ self class
	      base: base
		sign: aString
		integerPart: integerPart
		fractionalPart: fractionalPart
		exponentSign: exponentSign
		exponent: aString
		scale: NotPresent! !

!PPSmalltalkNumberMaker methodsFor: 'copying' stamp: 'fbs 9/8/2011 07:56'!
withExponentSign: aString
	^ self class
	      base: base
		sign: sign
		integerPart: integerPart
		fractionalPart: fractionalPart
		exponentSign: exponentSign
		exponent: aString
		scale: NotPresent! !

!PPSmalltalkNumberMaker methodsFor: 'copying' stamp: 'fbs 9/7/2011 21:22'!
withFractionalPart: aString
	^ self class
	      base: base
		sign: sign
		integerPart: integerPart
		fractionalPart: aString
		exponentSign: exponentSign
		exponent: exponent
		scale: NotPresent! !

!PPSmalltalkNumberMaker methodsFor: 'copying' stamp: 'fbs 9/7/2011 07:45'!
withScale: aString
	^ self class
	      base: base
		sign: sign
		integerPart: integerPart
		fractionalPart: fractionalPart
		exponentSign: NotPresent
		exponent: NotPresent
		scale: aString! !

!PPSmalltalkNumberMaker methodsFor: 'copying' stamp: 'fbs 9/6/2011 17:31'!
withSign: aString
	^ self class
	      base: base
		sign: aString
		integerPart: integerPart
		fractionalPart: fractionalPart
		exponentSign: exponentSign
		exponent: exponent
		scale: scale! !

PPCompositeParser subclass: #PPSmalltalkGrammar
	instanceVariableNames: 'array arrayItem arrayLiteral arrayLiteralArray assignment assignmentToken binary binaryExpression binaryMessage binaryMethod binaryPragma binaryToken block blockArgument blockArguments blockArgumentsWith blockArgumentsWithout blockBody byteLiteral byteLiteralArray cascadeExpression cascadeMessage char charLiteral charToken expression falseLiteral falseToken identifier identifierToken keyword keywordExpression keywordMessage keywordMethod keywordPragma keywordToken literal message method methodDeclaration methodSequence multiword nilLiteral nilToken number numberLiteral numberToken parens period periodToken pragma pragmaMessage pragmas primary return sequence startExpression startMethod statements string stringLiteral stringToken symbol symbolLiteral symbolLiteralArray temporaries trueLiteral trueToken unary unaryExpression unaryMessage unaryMethod unaryPragma unaryToken variable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitSmalltalk-Core'!

!PPSmalltalkGrammar commentStamp: 'lr 11/29/2009 09:58' prior: 0!
A parser for Smalltalk methods and expressions.!

!PPSmalltalkGrammar class methodsFor: 'testing' stamp: 'lr 7/11/2011 11:27'!
allowUnderscoreAssignment
	^ Scanner allowUnderscoreAsAssignment! !

!PPSmalltalkGrammar class methodsFor: 'accessing' stamp: 'lr 2/19/2010 08:08'!
parseExpression: aString
	^ self new parseExpression: aString! !

!PPSmalltalkGrammar class methodsFor: 'accessing' stamp: 'lr 2/19/2010 08:09'!
parseExpression: aString onError: aBlock
	^ self new parseExpression: aString onError: aBlock! !

!PPSmalltalkGrammar class methodsFor: 'accessing' stamp: 'lr 2/19/2010 08:09'!
parseMethod: aString
	^ self new parseMethod: aString! !

!PPSmalltalkGrammar class methodsFor: 'accessing' stamp: 'lr 2/19/2010 08:09'!
parseMethod: aString onError: aBlock
	^ self new parseMethod: aString onError: aBlock! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 8/14/2011 11:30'!
array
	^ ${ asParser smalltalkToken , (expression delimitedBy: periodToken) optional , $} asParser smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'TestRunner 10/23/2009 17:39'!
arrayItem
	^ literal / symbolLiteralArray / arrayLiteralArray / byteLiteralArray! !

!PPSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 6/29/2010 14:30'!
arrayLiteral
	^ '#(' asParser smalltalkToken , arrayItem star , $) asParser smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 6/29/2010 14:30'!
arrayLiteralArray
	^ $( asParser smalltalkToken , arrayItem star , $) asParser smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 9/27/2009 12:42'!
assignment
	^ variable , assignmentToken! !

!PPSmalltalkGrammar methodsFor: 'token' stamp: 'lr 7/11/2011 11:27'!
assignmentToken
	^ self class allowUnderscoreAssignment
		ifTrue: [ (':=' asParser / '_' asParser) smalltalkToken ]
		ifFalse: [ ':=' asParser smalltalkToken ]! !

!PPSmalltalkGrammar methodsFor: 'primitives' stamp: 'lr 8/11/2011 23:29'!
binary
	^ (PPPredicateObjectParser anyOf: '!!%&*+,-/<=>?@\|~') plus! !

!PPSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'lr 9/27/2009 12:42'!
binaryExpression
	^ unaryExpression , binaryMessage star! !

!PPSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'lr 12/6/2009 10:38'!
binaryMessage
	^ (binaryToken , unaryExpression) ==> [ :nodes | 
		Array 
			with: (Array with: nodes first)
			with: (Array with: nodes second) ]! !

!PPSmalltalkGrammar methodsFor: 'grammar-methods' stamp: 'lr 12/6/2009 10:38'!
binaryMethod
	^ (binaryToken , variable) ==> [ :nodes | 
		Array 
			with: (Array with: nodes first)
			with: (Array with: nodes second) ]! !

!PPSmalltalkGrammar methodsFor: 'grammar-pragmas' stamp: 'TestRunner 10/23/2009 17:34'!
binaryPragma
	^ (binaryToken , arrayItem) ==> [ :nodes | 
		Array 
			with: (Array with: nodes first)
			with: (Array with: nodes second) ]! !

!PPSmalltalkGrammar methodsFor: 'token' stamp: 'lr 6/29/2010 14:30'!
binaryToken
	^ binary smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'grammar-blocks' stamp: 'lr 6/29/2010 14:30'!
block
	^ $[ asParser smalltalkToken , blockBody , $] asParser smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'grammar-blocks' stamp: 'lr 6/29/2010 14:30'!
blockArgument
	^ $: asParser smalltalkToken , variable! !

!PPSmalltalkGrammar methodsFor: 'grammar-blocks' stamp: 'lr 2/4/2010 13:21'!
blockArguments
	^ blockArgumentsWith / blockArgumentsWithout! !

!PPSmalltalkGrammar methodsFor: 'grammar-blocks' stamp: 'lr 6/29/2010 14:30'!
blockArgumentsWith
	^ blockArgument plus , ($| asParser smalltalkToken / ($] asParser smalltalkToken and ==> [ :node | nil ]))! !

!PPSmalltalkGrammar methodsFor: 'grammar-blocks' stamp: 'lr 2/4/2010 11:44'!
blockArgumentsWithout
	^ nil asParser ==> [ :nodes | Array with: #() with: nil ]! !

!PPSmalltalkGrammar methodsFor: 'grammar-blocks' stamp: 'lr 2/4/2010 11:39'!
blockBody
	^ blockArguments , sequence! !

!PPSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 6/29/2010 14:30'!
byteLiteral
	^ '#[' asParser smalltalkToken , numberLiteral star , $] asParser smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 6/29/2010 14:30'!
byteLiteralArray
	^ $[ asParser smalltalkToken , numberLiteral star , $] asParser smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'lr 9/27/2009 12:42'!
cascadeExpression
	^ keywordExpression , cascadeMessage star! !

!PPSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'lr 6/29/2010 14:30'!
cascadeMessage
	^ $; asParser smalltalkToken , message! !

!PPSmalltalkGrammar methodsFor: 'primitives' stamp: 'lr 9/27/2009 12:42'!
char
	^ $$ asParser , #any asParser! !

!PPSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 9/27/2009 12:42'!
charLiteral
	^ charToken! !

!PPSmalltalkGrammar methodsFor: 'token' stamp: 'lr 6/29/2010 14:30'!
charToken
	^ char smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 9/27/2009 12:42'!
expression
	^ assignment star , cascadeExpression! !

!PPSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 9/27/2009 12:42'!
falseLiteral
	^ falseToken! !

!PPSmalltalkGrammar methodsFor: 'token' stamp: 'lr 6/29/2010 14:30'!
falseToken
	^ ('false' asParser , #word asParser not) smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'primitives' stamp: 'lr 7/11/2011 11:32'!
identifier
	^ self class allowUnderscoreAssignment
		ifTrue: [ #letter asParser , #word asParser star ]
		ifFalse: [
			(PPPredicateObjectParser
				on: [ :each | each isLetter or: [ each = $_ ] ]
				message: 'letter expected') ,
			(PPPredicateObjectParser
				on: [ :each | each isAlphaNumeric or: [ each = $_ ] ]
				message: 'letter or digit expected') star ]! !

!PPSmalltalkGrammar methodsFor: 'token' stamp: 'lr 6/29/2010 14:30'!
identifierToken
	^ identifier smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'primitives' stamp: 'lr 9/27/2009 12:42'!
keyword
	^ identifier , $: asParser! !

!PPSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'lr 9/27/2009 12:42'!
keywordExpression
	^ binaryExpression , keywordMessage optional! !

!PPSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'lr 12/6/2009 10:38'!
keywordMessage
	^ (keywordToken , binaryExpression) plus ==> [ :nodes | 
		Array 
			with: (nodes collect: [ :each | each first ])
			with: (nodes collect: [ :each | each second ]) ]! !

!PPSmalltalkGrammar methodsFor: 'grammar-methods' stamp: 'lr 12/6/2009 10:38'!
keywordMethod
	^ (keywordToken , variable) plus ==> [ :nodes | 
		Array 
			with: (nodes collect: [ :each | each first ])
			with: (nodes collect: [ :each | each second ]) ]! !

!PPSmalltalkGrammar methodsFor: 'grammar-pragmas' stamp: 'TestRunner 10/23/2009 17:35'!
keywordPragma
	^ (keywordToken , arrayItem) plus ==> [ :nodes | 
		Array 
			with: (nodes collect: [ :each | each first ])
			with: (nodes collect: [ :each | each second ]) ]! !

!PPSmalltalkGrammar methodsFor: 'token' stamp: 'lr 6/29/2010 14:30'!
keywordToken
	^ keyword smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 5/3/2010 21:46'!
literal
	^ numberLiteral / stringLiteral / charLiteral / arrayLiteral / byteLiteral / symbolLiteral / nilLiteral / trueLiteral / falseLiteral! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 9/27/2009 12:42'!
message
	^ keywordMessage / binaryMessage / unaryMessage! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 9/27/2009 12:42'!
method
	^ methodDeclaration , methodSequence! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 9/27/2009 12:42'!
methodDeclaration
	^ keywordMethod / unaryMethod / binaryMethod! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 8/14/2011 11:23'!
methodSequence
	^ periodToken star , pragmas , periodToken star , temporaries , periodToken star , pragmas , periodToken star , statements! !

!PPSmalltalkGrammar methodsFor: 'primitives' stamp: 'lr 9/27/2009 12:42'!
multiword
	^ keyword plus! !

!PPSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 9/27/2009 12:42'!
nilLiteral
	^ nilToken! !

!PPSmalltalkGrammar methodsFor: 'token' stamp: 'lr 6/29/2010 14:30'!
nilToken
	^ ('nil' asParser , #word asParser not) smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'primitives' stamp: 'fbs 8/17/2011 17:40'!
number
	^ PPSmalltalkNumberGrammar new number! !

!PPSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 9/27/2009 12:42'!
numberLiteral
	^ numberToken! !

!PPSmalltalkGrammar methodsFor: 'token' stamp: 'lr 6/29/2010 14:30'!
numberToken
	^ number smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 6/29/2010 14:30'!
parens
	^ $( asParser smalltalkToken , expression , $) asParser smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'parsing' stamp: 'lr 2/19/2010 08:00'!
parseExpression: aString 
	^ self parseExpression: aString onError: [ :msg :pos | self error: msg ]! !

!PPSmalltalkGrammar methodsFor: 'parsing' stamp: 'lr 2/19/2010 08:04'!
parseExpression: aString onError: aBlock
	^ startExpression parse: aString onError: aBlock! !

!PPSmalltalkGrammar methodsFor: 'parsing' stamp: 'lr 2/19/2010 08:01'!
parseMethod: aString 
	^ self parseMethod: aString onError: [ :msg :pos | self error: msg ]! !

!PPSmalltalkGrammar methodsFor: 'parsing' stamp: 'lr 2/19/2010 08:04'!
parseMethod: aString onError: aBlock
	^ startMethod parse: aString onError: aBlock! !

!PPSmalltalkGrammar methodsFor: 'primitives' stamp: 'lr 8/13/2011 20:51'!
period
	^ $. asParser! !

!PPSmalltalkGrammar methodsFor: 'token' stamp: 'lr 8/13/2011 20:52'!
periodToken
	^ period smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 6/29/2010 14:30'!
pragma
	^ $< asParser smalltalkToken , pragmaMessage , $> asParser smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'grammar-pragmas' stamp: 'lr 9/27/2009 12:42'!
pragmaMessage
	^ keywordPragma / unaryPragma / binaryPragma! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 9/27/2009 12:42'!
pragmas
	^ pragma star! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 5/3/2010 21:39'!
primary
	^ literal / variable / block / parens / array! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 6/29/2010 14:30'!
return
	^ $^ asParser smalltalkToken , expression! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 8/14/2011 11:13'!
sequence
	^ temporaries , periodToken star , statements! !

!PPSmalltalkGrammar methodsFor: 'accessing' stamp: 'lr 2/19/2010 08:05'!
start
	"Default start production."

	^ startMethod! !

!PPSmalltalkGrammar methodsFor: 'accessing' stamp: 'lr 2/19/2010 08:03'!
startExpression
	"Start production for the expression."

	^ sequence end! !

!PPSmalltalkGrammar methodsFor: 'accessing' stamp: 'lr 2/19/2010 08:03'!
startMethod
	"Start production for the method."

	^ method end! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 6/29/2010 14:30'!
statements
	^ 	(expression wrapped , (($. asParser smalltalkToken plus , statements ==> [ :nodes | nodes first , nodes last ])
								/ $. asParser smalltalkToken star)
			==> [ :nodes | (Array with: nodes first) , (nodes last) ])
	/	(return , $. asParser smalltalkToken star
			==> [ :nodes | (Array with: nodes first) , (nodes last) ])
	/	($. asParser smalltalkToken star)! !

!PPSmalltalkGrammar methodsFor: 'primitives' stamp: 'lr 1/8/2010 15:38'!
string
	^ $' asParser , ('''''' asParser / $' asParser negate) star , $' asParser! !

!PPSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 9/27/2009 12:42'!
stringLiteral
	^ stringToken! !

!PPSmalltalkGrammar methodsFor: 'token' stamp: 'lr 6/29/2010 14:30'!
stringToken
	^ string smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'primitives' stamp: 'lr 9/27/2009 12:42'!
symbol
	^ unary / binary / multiword / string! !

!PPSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 8/14/2011 12:27'!
symbolLiteral
	"This is totally fucked up: The Pharo compiler allows multiple #, arbitrary spaces between the # and the symbol, as well as comments inbetween. And yes, it is used."

	^ $# asParser smalltalkToken plus , symbol smalltalkToken ==> [ :tokens | tokens first copyWith: tokens last ]! !

!PPSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 6/29/2010 14:30'!
symbolLiteralArray
	^ symbol smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 6/29/2010 14:30'!
temporaries
	^ ($| asParser smalltalkToken , variable star , $| asParser smalltalkToken) optional ==> [ :nodes | nodes ifNil: [ #() ] ]! !

!PPSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 9/27/2009 12:42'!
trueLiteral
	^ trueToken! !

!PPSmalltalkGrammar methodsFor: 'token' stamp: 'lr 6/29/2010 14:30'!
trueToken
	^ ('true' asParser , #word asParser not) smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'primitives' stamp: 'lr 9/27/2009 12:42'!
unary
	^ identifier , $: asParser not! !

!PPSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'lr 9/27/2009 12:42'!
unaryExpression
	^ primary , unaryMessage star! !

!PPSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'lr 12/6/2009 10:39'!
unaryMessage
	^ unaryToken ==> [ :node | 
		Array 
			with: (Array with: node)
			with: Array new ]! !

!PPSmalltalkGrammar methodsFor: 'grammar-methods' stamp: 'lr 12/6/2009 10:39'!
unaryMethod
	^ identifierToken ==> [ :node | 
		Array 
			with: (Array with: node)
			with: Array new ]! !

!PPSmalltalkGrammar methodsFor: 'grammar-pragmas' stamp: 'TestRunner 10/23/2009 16:35'!
unaryPragma
	^ identifierToken ==> [ :node | 
		Array 
			with: (Array with: node)
			with: (Array new) ]! !

!PPSmalltalkGrammar methodsFor: 'token' stamp: 'lr 6/29/2010 14:30'!
unaryToken
	^ unary smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 9/27/2009 12:42'!
variable
	^ identifierToken! !

PPSmalltalkGrammar subclass: #PPSmalltalkParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitSmalltalk-Core'!

!PPSmalltalkParser commentStamp: 'lr 11/29/2009 09:58' prior: 0!
Enhances the Smalltalk grammar with production actions to build parse-tree nodes of the refactoring browser.!

!PPSmalltalkParser methodsFor: 'private' stamp: 'lr 8/14/2011 12:04'!
addStatements: aCollection into: aNode
	aCollection isNil 
		ifTrue: [ ^ aNode ].
	aCollection do: [ :each |
		each class == PPSmalltalkToken
			ifFalse: [ aNode addNode:  each ]
			ifTrue: [
				aNode statements isEmpty
					ifTrue: [ aNode addComments: each comments ]
					ifFalse: [ aNode statements last addComments: each comments ].
				aNode periods: (aNode periods asOrderedCollection
					addLast: each start;
					yourself) ] ].
	^ aNode! !

!PPSmalltalkParser methodsFor: 'grammar' stamp: 'lr 8/14/2011 11:51'!
array
	^ super array map: [ :openNode :statementNodes :closeNode |
		(self buildArray: statementNodes)
			left: openNode start;
			right: closeNode start;
			yourself ]! !

!PPSmalltalkParser methodsFor: 'grammar-literals' stamp: 'TestRunner 11/5/2009 11:41'!
arrayLiteral
	^ super arrayLiteral ==> [ :nodes | RBLiteralArrayNode startPosition: nodes first start contents: nodes second stopPosition: nodes last start isByteArray: false ]! !

!PPSmalltalkParser methodsFor: 'grammar-literals' stamp: 'TestRunner 11/5/2009 11:41'!
arrayLiteralArray
	^ super arrayLiteralArray ==> [ :nodes | RBLiteralArrayNode startPosition: nodes first start contents: nodes second stopPosition: nodes last start isByteArray: false ]! !

!PPSmalltalkParser methodsFor: 'grammar-messages' stamp: 'lr 12/6/2009 10:39'!
binaryExpression
	^ super binaryExpression map: [ :receiverNode :messageNodes | self build: receiverNode messages: messageNodes ]! !

!PPSmalltalkParser methodsFor: 'grammar-blocks' stamp: 'lr 12/6/2009 10:37'!
block
	^ super block map: [ :leftToken :blockNode :rightToken | blockNode left: leftToken start; right: rightToken start ]! !

!PPSmalltalkParser methodsFor: 'grammar-blocks' stamp: 'lr 9/27/2009 12:42'!
blockArgument
	^ super blockArgument ==> #second! !

!PPSmalltalkParser methodsFor: 'grammar-blocks' stamp: 'lr 2/4/2010 11:42'!
blockBody
	^ super blockBody ==> [ :nodes | 
		| result |
		result := RBBlockNode arguments: nodes first first body: nodes last.
		nodes first last isNil
			ifFalse: [ result bar: nodes first last start ].
		result ]! !

!PPSmalltalkParser methodsFor: 'private' stamp: 'TestRunner 11/5/2009 10:36'!
build: aNode assignment: anArray
	^ anArray isEmpty
		ifTrue: [ aNode ]
		ifFalse: [
			anArray reverse 
				inject: aNode
				into: [ :result :each |
					RBAssignmentNode 
						variable: each first
						value: result
						position: each second start ] ]! !

!PPSmalltalkParser methodsFor: 'private' stamp: 'lr 9/11/2010 10:11'!
build: aNode cascade: anArray 
	| messages semicolons |
	^ (anArray isNil or: [ anArray isEmpty ]) 
		ifTrue: [ aNode ]
		ifFalse: [
			messages := OrderedCollection new: anArray size + 1.
			messages addLast: aNode.
			semicolons := OrderedCollection new.
			anArray do: [ :each | 
				messages addLast: (self 
					build: aNode receiver
					messages: (Array with: each second)).
				semicolons addLast: each first start ].
			RBCascadeNode messages: messages semicolons: semicolons ]! !

!PPSmalltalkParser methodsFor: 'private' stamp: 'lr 11/5/2009 10:44'!
build: aNode messages: anArray 
	^ (anArray isNil or: [ anArray isEmpty ]) 
		ifTrue: [ aNode ]
		ifFalse: [
			anArray 
				inject: aNode
				into: [ :rec :msg | 
					msg isNil 
						ifTrue: [ rec ]
						ifFalse: [
							RBMessageNode 
								receiver: rec
								selectorParts: msg first
								arguments: msg second ] ] ]! !

!PPSmalltalkParser methodsFor: 'private' stamp: 'lr 8/14/2011 12:03'!
build: aTempCollection sequence: aStatementCollection
	| result |
	result := self
		addStatements: aStatementCollection
		into: RBSequenceNode new.
	aTempCollection isEmpty ifFalse: [
		result
			leftBar: aTempCollection first start
			temporaries: aTempCollection second
			rightBar: aTempCollection last start ].
	^ result! !

!PPSmalltalkParser methodsFor: 'private' stamp: 'lr 8/14/2011 12:00'!
buildArray: aStatementCollection
	^ self addStatements: aStatementCollection into: RBArrayNode new! !

!PPSmalltalkParser methodsFor: 'private' stamp: 'lr 3/1/2010 10:51'!
buildMethod: aMethodNode
	aMethodNode selectorParts 
		do: [ :each | aMethodNode addComments: each comments ].
	aMethodNode arguments
		do: [ :each | aMethodNode addComments: each token comments ].
	aMethodNode pragmas do: [ :pragma |
		aMethodNode addComments: pragma comments.
		pragma selectorParts 
			do: [ :each | aMethodNode addComments: each comments ].
		pragma arguments do: [ :each | 
			each isLiteralArray
				ifFalse: [ aMethodNode addComments: each token comments ] ].
		pragma comments: nil ].
	^ aMethodNode! !

!PPSmalltalkParser methodsFor: 'private' stamp: 'lr 8/14/2011 12:25'!
buildString: aString 
	(aString isEmpty or: [ aString first ~= $' or: [ aString last ~= $' ] ])
		ifTrue: [ ^ aString ].
	^ (aString 
		copyFrom: 2
		to: aString size - 1) 
		copyReplaceAll: ''''''
		with: ''''! !

!PPSmalltalkParser methodsFor: 'grammar-literals' stamp: 'TestRunner 11/5/2009 11:41'!
byteLiteral
	^ super byteLiteral ==> [ :nodes | RBLiteralArrayNode startPosition: nodes first start contents: nodes second stopPosition: nodes last start isByteArray: true ]! !

!PPSmalltalkParser methodsFor: 'grammar-literals' stamp: 'TestRunner 11/5/2009 11:41'!
byteLiteralArray
	^ super byteLiteralArray ==> [ :nodes | RBLiteralArrayNode startPosition: nodes first start contents: nodes second stopPosition: nodes last start isByteArray: true ]! !

!PPSmalltalkParser methodsFor: 'grammar-messages' stamp: 'lr 12/6/2009 10:40'!
cascadeExpression
	^ super cascadeExpression map: [ :receiverNode :messageNodes | self build: receiverNode cascade: messageNodes ]! !

!PPSmalltalkParser methodsFor: 'grammar-literals' stamp: 'TestRunner 11/5/2009 11:28'!
charLiteral
	^ super charLiteral ==> [ :token | RBLiteralValueNode literalToken: (RBLiteralToken value: token value second start: token start stop: token stop) ]! !

!PPSmalltalkParser methodsFor: 'grammar' stamp: 'lr 12/6/2009 10:40'!
expression
	^ super expression map: [ :variableNodes :expressionNodes | self build: expressionNodes assignment: variableNodes ]! !

!PPSmalltalkParser methodsFor: 'grammar-literals' stamp: 'TestRunner 11/5/2009 11:29'!
falseLiteral
	^ super falseLiteral ==> [ :token | RBLiteralValueNode literalToken: (RBLiteralToken value: false start: token start stop: token stop) ]! !

!PPSmalltalkParser methodsFor: 'grammar-messages' stamp: 'lr 12/6/2009 10:41'!
keywordExpression
	^ super keywordExpression map: [ :receiveNode :messageNode | self build: receiveNode messages: (Array with: messageNode) ]! !

!PPSmalltalkParser methodsFor: 'grammar' stamp: 'lr 8/13/2011 21:09'!
method
	^ super method map: [ :methodNode :bodyNode | 
		methodNode pragmas: bodyNode first.
		methodNode body: bodyNode second.
		self buildMethod: methodNode ]! !

!PPSmalltalkParser methodsFor: 'grammar' stamp: 'lr 3/1/2010 10:27'!
methodDeclaration
	^ super methodDeclaration ==> [ :nodes |
		RBMethodNode 
			selectorParts: nodes first
			arguments: nodes second ]! !

!PPSmalltalkParser methodsFor: 'grammar' stamp: 'lr 8/14/2011 11:24'!
methodSequence
	^ super methodSequence map: [ :periodNodes1 :pragmaNodes1 :periodNodes2 :tempNodes :periodNodes3 :pragmaNodes2 :periodNodes4 :statementNodes |
		Array
			with: pragmaNodes1 , pragmaNodes2
			with: (self build: tempNodes sequence: periodNodes1 , periodNodes2 , periodNodes3 , periodNodes4 , statementNodes) ]! !

!PPSmalltalkParser methodsFor: 'grammar-literals' stamp: 'TestRunner 11/5/2009 11:29'!
nilLiteral
	^ super nilLiteral ==> [ :token | RBLiteralValueNode literalToken: (RBLiteralToken value: nil start: token start stop: token stop) ]! !

!PPSmalltalkParser methodsFor: 'grammar-literals' stamp: 'TestRunner 11/5/2009 13:33'!
numberLiteral
	^ super numberLiteral ==> [ :token | RBLiteralValueNode literalToken: (RBNumberLiteralToken value: (Number readFrom: token value) start: token start stop: token stop source: token value) ]! !

!PPSmalltalkParser methodsFor: 'grammar' stamp: 'lr 12/6/2009 10:42'!
parens
	^ super parens map: [ :openToken :expressionNode :closeToken | expressionNode addParenthesis: (openToken start to: closeToken start) ]! !

!PPSmalltalkParser methodsFor: 'grammar' stamp: 'lr 3/1/2010 10:50'!
pragma
	^ super pragma ==> [ :nodes | 
		(RBPragmaNode selectorParts: nodes second first arguments: nodes second second)
			addComments: nodes first comments;
			addComments: nodes last comments;
			left: nodes first start;
			right: nodes last start;
			yourself ]! !

!PPSmalltalkParser methodsFor: 'grammar' stamp: 'lr 12/6/2009 10:42'!
return
	^ super return map: [ :token :expressionNode | RBReturnNode return: token start value: expressionNode ]! !

!PPSmalltalkParser methodsFor: 'grammar' stamp: 'lr 8/14/2011 11:14'!
sequence
	^ super sequence map: [ :tempNodes :periodNodes :statementNodes | self build: tempNodes sequence: periodNodes , statementNodes ]! !

!PPSmalltalkParser methodsFor: 'accessing' stamp: 'lr 2/19/2010 08:07'!
startExpression
	"Make the sequence node has a method node as its parent and that the source is set."

	^ ([ :stream | stream collection ] asParser and , super startExpression) map: [ :source :node | 
		(RBMethodNode selector: #doIt body: node)
			source: source.
		(node statements size = 1 and: [ node temporaries isEmpty ])
			ifTrue: [ node statements first ]
			ifFalse: [ node ] ]! !

!PPSmalltalkParser methodsFor: 'accessing' stamp: 'lr 2/19/2010 08:20'!
startMethod
	"Make sure the method node has the source code properly set."
	
	^ ([ :stream | stream collection ] asParser and , super startMethod)
		map: [ :source :node | node source: source ]! !

!PPSmalltalkParser methodsFor: 'grammar-literals' stamp: 'TestRunner 11/5/2009 11:30'!
stringLiteral
	^ super stringLiteral ==> [ :token | RBLiteralValueNode literalToken: (RBLiteralToken value: (self buildString: token value) start: token start stop: token stop) ]! !

!PPSmalltalkParser methodsFor: 'grammar-literals' stamp: 'lr 8/14/2011 12:24'!
symbolLiteral
	^ super symbolLiteral ==> [ :tokens | RBLiteralValueNode literalToken: (RBLiteralToken value: (self buildString: tokens last value) asSymbol start: tokens first start stop: tokens last stop) ]! !

!PPSmalltalkParser methodsFor: 'grammar-literals' stamp: 'TestRunner 11/5/2009 11:45'!
symbolLiteralArray
	^ super symbolLiteralArray ==> [ :token | RBLiteralValueNode literalToken: (RBLiteralToken value: (self buildString: token value) asSymbol start: token start stop: token stop) ]! !

!PPSmalltalkParser methodsFor: 'grammar-literals' stamp: 'TestRunner 11/5/2009 11:29'!
trueLiteral
	^ super trueLiteral ==> [ :token | RBLiteralValueNode literalToken: (RBLiteralToken value: true start: token start stop: token stop) ]! !

!PPSmalltalkParser methodsFor: 'grammar-messages' stamp: 'lr 12/6/2009 10:43'!
unaryExpression
	^ super unaryExpression map: [ :receiverNode :messageNodes | self build: receiverNode messages: messageNodes ]! !

!PPSmalltalkParser methodsFor: 'grammar' stamp: 'lr 9/27/2009 12:42'!
variable
	^ super variable ==> [ :token | RBVariableNode identifierToken: token ]! !

PPCompositeParser subclass: #PPSmalltalkNumberGrammar
	instanceVariableNames: 'exponent digits number signedDigits decimalNumber scale sign'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitSmalltalk-Core'!

!PPSmalltalkNumberGrammar commentStamp: 'fbs 8/15/2011 07:54' prior: 0!
I describe how to parse Smalltalk number literals, viz., integers, floats and scaled decimals.!

!PPSmalltalkNumberGrammar methodsFor: 'grammar' stamp: 'fbs 9/8/2011 12:22'!
decimalNumber
	^ (signedDigits , ($. asParser , digits) optional) , (exponent / scale) optional! !

!PPSmalltalkNumberGrammar methodsFor: 'helpers' stamp: 'fbs 9/8/2011 07:47'!
digits
	^ self digitsBase: 10.! !

!PPSmalltalkNumberGrammar methodsFor: 'helpers' stamp: 'fbs 9/8/2011 07:48'!
digitsBase: radix
	| lowercaseDigits uppercaseDigits |
	lowercaseDigits := ($0 to: $9) , ($a to: $z).
	uppercaseDigits := ($0 to: $9) , ($A to: $Z).
	^ ((PPPredicateObjectParser anyOf: (lowercaseDigits first: radix))
		/ (PPPredicateObjectParser anyOf: (uppercaseDigits first: radix))) plus flatten! !

!PPSmalltalkNumberGrammar methodsFor: 'helpers' stamp: 'fbs 9/7/2011 21:39'!
digitsToInteger: someDigits
	^ PPSmalltalkNumberMaker makeInteger: someDigits.! !

!PPSmalltalkNumberGrammar methodsFor: 'helpers' stamp: 'fbs 9/8/2011 07:47'!
exponent
	"Even in a radix-prefixed float, the digits in the exponent are decimal."
	^ (PPPredicateObjectParser anyOf: 'edq') , sign optional , digits! !

!PPSmalltalkNumberGrammar methodsFor: 'grammar' stamp: 'fbs 9/3/2011 22:55'!
number
	^ [:stream | | result |
		result := ($- asParser optional , digits flatten , $r asParser optional) and parseOn: stream.
		result isPetitFailure
			ifTrue: [PPFailure message: 'Digit expected' at: stream position]
			ifFalse: [
				"result first is the optional sign. result second is the sequence of digits."
				"result third is the possible $r, indicating an explicit radix."
				result third
					ifNil: [decimalNumber parseOn: stream]
					ifNotNil: [ | radix |
						radix := self strToRadix: result second at: stream position.
						radix isPetitFailure
							ifTrue: [radix]
							ifFalse: [(self numberBase: radix) parseOn: stream]]]] asParser! !

!PPSmalltalkNumberGrammar methodsFor: 'grammar' stamp: 'fbs 9/8/2011 12:22'!
numberBase: radix
	^ signedDigits , $r asParser , (self signedDigitsBase: radix) , ($. asParser , (self digitsBase: radix)) optional , (exponent / scale) optional! !

!PPSmalltalkNumberGrammar methodsFor: 'helpers' stamp: 'fbs 8/16/2011 17:48'!
scale
	"Scale is the _decimal_ number of significant places."
	^ $s asParser , digits.! !

!PPSmalltalkNumberGrammar methodsFor: 'helpers' stamp: 'fbs 8/19/2011 07:50'!
sign
	^ $- asParser / $+ asParser! !

!PPSmalltalkNumberGrammar methodsFor: 'helpers' stamp: 'fbs 8/15/2011 17:57'!
signedDigits
	^ self signedDigitsBase: 10.! !

!PPSmalltalkNumberGrammar methodsFor: 'helpers' stamp: 'fbs 8/18/2011 17:32'!
signedDigitsBase: radix
	^ $- asParser optional , (self digitsBase: radix)! !

!PPSmalltalkNumberGrammar methodsFor: 'accessing' stamp: 'fbs 8/15/2011 17:42'!
start
	^ number! !

!PPSmalltalkNumberGrammar methodsFor: 'helpers' stamp: 'fbs 9/3/2011 21:54'!
strToRadix: aString at: streamPosition
	"aString should contain nothing other than a string representation of a number r such that 2 <= r <= 36."
	| toInt radix |
	(#(1 2) includes: aString size)
		ifFalse: [^ PPFailure message: 'Invalid radix' at: streamPosition].
	
	toInt := [:c | c codePoint - $0 codePoint].
	radix := (aString size = 1)
		ifTrue: [toInt value: aString first]
		ifFalse: [(10 * (toInt value: aString first)) + (toInt value: aString second)].
	(radix between: 2 and: 36)
		ifFalse: [^ PPFailure message: 'Invalid radix' at: streamPosition].
		
	^ radix.! !

PPSmalltalkNumberGrammar subclass: #PPSmalltalkNumberParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitSmalltalk-Core'!

!PPSmalltalkNumberParser methodsFor: 'grammar' stamp: 'fbs 9/8/2011 12:27'!
decimalNumber
	^ super decimalNumber ==> [:nodes | self makeNumberFrom: nodes base: 10]! !

!PPSmalltalkNumberParser methodsFor: 'helpers' stamp: 'fbs 9/8/2011 12:26'!
makeNumberFrom: nodes base: radix
	| number signChar integerPartString fractionalPartString exponentSignString exponentString scaleString |
	signChar := nodes first first.
	integerPartString := nodes first second.
	fractionalPartString := nodes second ifNil: [nil] ifNotNil: [nodes second second].
	nodes third
		ifNotNil: [
			"first is the e, d, q, or the s. second is the sign. third is the actual exponent."
			(nodes third first = $s)
				ifTrue: [scaleString := nodes third second]
				ifFalse: [
					nodes third ifNotNil: [exponentSignString := nodes third second].
					nodes third ifNotNil: [exponentString := nodes third third]]].
	number := (PPSmalltalkNumberMaker integerPart: integerPartString) withBase: radix.
	signChar ifNotNil: [number := number withSign: signChar asString].
	fractionalPartString ifNotNil: [number := number withFractionalPart: fractionalPartString].
	exponentSignString ifNotNil: [number := number withExponentSign: exponentSignString].
	exponentString ifNotNil: [number := number withExponentSign: exponentString].
	scaleString ifNotNil: [number := number withScale: scaleString].
	^ number makeNumber.! !

!PPSmalltalkNumberParser methodsFor: 'grammar' stamp: 'fbs 9/8/2011 12:21'!
numberBase: radix
	^ (super numberBase: radix) ==> [:nodes |	| number baseSignChar base |
	baseSignChar := nodes first first.
	base := (PPSmalltalkNumberMaker makeInteger: nodes first second).
	number := self makeNumberFrom: (nodes allButFirst: 2) base: base.
	(baseSignChar = $-)
		ifTrue: [number := number negated].
	number]! !

PPCompositeParserTest subclass: #PPSmalltalkClassesTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitSmalltalk-Tests'!

!PPSmalltalkClassesTests commentStamp: 'lr 3/26/2009 16:09' prior: 0!
Evalaute the following code to verify the complete image.

PackageOrganizer default packages
	inject: LAPackagesTests new
	into: [ :test :package | 
		[ test verifyPackage: package packageName ]
			on: TestResult resumableFailure
			do: [ :err | err resume ] ]!

!PPSmalltalkClassesTests class methodsFor: 'utilities' stamp: 'lr 8/14/2011 13:32'!
benchmark: aParser
	"self benchmark: PPSmalltalkGrammar new"
	"self benchmark: PPSmalltalkParser new"
	"self benchmark: RBParser"
	
	| sources |
	sources := OrderedCollection new.
	SequenceableCollection withAllSubclassesDo: [ :class |
		class selectors do: [ :selector |
			sources add: (class sourceCodeAt: selector) ] ].
	^ self benchmark: aParser sources: sources asArray! !

!PPSmalltalkClassesTests class methodsFor: 'utilities' stamp: 'lr 8/17/2011 23:56'!
benchmark: aParser sources: aCollection
	| count start |
	count := 0.
	start := Time millisecondClockValue.
	[  aCollection do: [ :each | aParser parseMethod: each ].
		count := count + 1.
		(Time millisecondsSince: start) < 10000 ] whileTrue.
	^ (1000 * count * (aCollection detectSum: [ :each | each size ]) 
		/ (Time millisecondsSince: start)) asInteger asString , ' characters/sec'! !

!PPSmalltalkClassesTests class methodsFor: 'accessing' stamp: 'lr 11/29/2010 11:36'!
packageNamesUnderTest
	^ #('PetitSmalltalk')! !

!PPSmalltalkClassesTests class methodsFor: 'utilities' stamp: 'lr 8/11/2011 23:41'!
verifySystem
	Smalltalk globals allClasses
		inject: self new
		into: [ :test :class | test verifyClass: class ]! !

!PPSmalltalkClassesTests methodsFor: 'private' stamp: 'lr 9/27/2009 12:43'!
assert: aBoolean description: aString 
	self 
		assert: aBoolean
		description: aString
		resumable: true! !

!PPSmalltalkClassesTests methodsFor: 'accessing' stamp: 'lr 12/7/2009 09:05'!
parserClass
	^ PPSmalltalkParser! !

!PPSmalltalkClassesTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testCollection
	self verifyClass: Collection.
	self verifyClass: Array.
	self verifyClass: Set.
	self verifyClass: Dictionary.
	self verifyClass: Bag.
	self verifyClass: OrderedCollection.
	self verifyClass: SortedCollection! !

!PPSmalltalkClassesTests methodsFor: 'testing' stamp: 'TestRunner 10/23/2009 18:13'!
testDateAndTime
	self verifyClass: DateAndTime.
	self verifyClass: Duration! !

!PPSmalltalkClassesTests methodsFor: 'testing' stamp: 'TestRunner 10/23/2009 18:12'!
testException
	self verifyClass: Exception.
	self verifyClass: Notification.
	self verifyClass: Warning.
	self verifyClass: Error! !

!PPSmalltalkClassesTests methodsFor: 'testing' stamp: 'TestRunner 10/23/2009 18:12'!
testFundamental
	self verifyClass: Object.
	self verifyClass: Boolean.
	self verifyClass: True.
	self verifyClass: False.
	self verifyClass: Character


! !

!PPSmalltalkClassesTests methodsFor: 'testing' stamp: 'TestRunner 10/23/2009 18:10'!
testMagnitude
	self verifyClass: Magnitude.
	self verifyClass: Number.
	self verifyClass: Integer.
	self verifyClass: Float.
	self verifyClass: Fraction! !

!PPSmalltalkClassesTests methodsFor: 'testing-protocol' stamp: 'lr 2/19/2010 09:13'!
testParseExpression
	result := self parserClass parseExpression: '1 + 2'.
	self assert: result isMessage.
	self assert: result source = '1 + 2'.
	
	result := self parserClass parseExpression: '| a | 1 + a'.
	self assert: result isSequence.
	self assert: result source =  '| a | 1 + a'.
	
	result := self parserClass parseExpression: '1 + 2. ^ 3'.
	self assert: result isSequence.
	self assert: result source = '1 + 2. ^ 3'.
	
	result := self parserClass parseExpression: '1 + ' onError: [ :err | true ].
	self assert: result.
	
	self 
		should: [ self parserClass parseExpression: '1 + ' ] 
		raise: Error! !

!PPSmalltalkClassesTests methodsFor: 'testing-protocol' stamp: 'lr 2/19/2010 09:13'!
testParseMethod
	result := self parserClass parseMethod: 'do 1 + 2'.
	self assert: result isMethod.
	self assert: result source = 'do 1 + 2'.
	
	result := self parserClass parseMethod: 'do 1 +' onError: [ :err | true ].
	self assert: result.
	
	self 
		should: [ self parserClass parseMethod: 'do 1 +' ]
		raise: Error! !

!PPSmalltalkClassesTests methodsFor: 'testing' stamp: 'TestRunner 10/23/2009 18:14'!
testStream
	self verifyClass: Stream.
	self verifyClass: ReadStream.
	self verifyClass: WriteStream! !

!PPSmalltalkClassesTests methodsFor: 'private' stamp: 'lr 5/1/2010 16:28'!
verifyClass: aClass 
	aClass selectors 
		do: [ :selector | self verifyClass: aClass selector: selector ].
	aClass isMeta
		ifFalse: [ self verifyClass: aClass class ]! !

!PPSmalltalkClassesTests methodsFor: 'private' stamp: 'lr 8/11/2011 23:58'!
verifyClass: aClass selector: aSelector 
	"Verifies that the method aSelector in aClass parses the same using the standard refactoring parser and the petit smalltalk parser. Also make sure that the position information of all tokens and comments is equal."

	| signature source original other checker |
	signature := aClass name , '>>#' , aSelector.
	source := aClass sourceCodeAt: aSelector.
	source isNil ifTrue: [ ^ self ].
	original := aClass parseTreeFor: aSelector.
	original isNil ifTrue: [ ^ self ].
	other := self parserInstance
		parseMethod: source
		onError: [ :err | self assert: false description: signature ].
	self 
		assert: original = other
		description: 'Code in ' , signature.
	checker := [ :node1 :node2 |
		self 
			assert: node1 sourceInterval = node2 sourceInterval 
			description: 'Source intervals in ' , signature.
		(node1 isArray or: [ node1 isBlock or: [ node1 isPragma ] ]) ifTrue: [
			self
				assert: node1 left = node2 left
				description: 'Source position left in ' , signature.
			self
				assert: node1 right = node2 right
				description: 'Source position right in ' , signature ].
		(node1 isSequence) ifTrue: [
			self
				assert: node1 leftBar = node2 leftBar
				description: 'Source position leftBar in ' , signature.
			self
				assert: node1 rightBar = node2 rightBar
				description: 'Source position rightBar in ' , signature ].
		(node1 isBlock) ifTrue: [.
			self
				assert: node1 bar = node2 bar
				description: 'Source position bar in ' , signature ].
		(node1 isReturn) ifTrue: [.
			self
				assert: node1 return = node2 return
				description: 'Source position return in ' , signature ].
		(node1 isAssignment) ifTrue: [.
			self
				assert: node1 assignment = node2 assignment
				description: 'Source position return in ' , signature ].
		(node1 isCascade) ifTrue: [.
			self
				assert: node1 semicolons asArray = node2 semicolons asArray
				description: 'Source position semicolons in ' , signature ].
		(node1 isArray or: [ node1 isSequence ]) ifTrue: [
			self
				assert: node1 periods asArray = node2 periods asArray
				description: 'Source position periods in ' , signature ].
		(node1 isMethod or: [ node1 isMessage or: [ node1 isPragma ] ]) ifTrue: [
			node1 selectorParts with: node2 selectorParts do: [ :a :b |
				self
					assert: a start = b start
					description: 'Source position selector parts in ' , signature ] ].
		node1 children with: node2 children do: checker ].
	checker value: original value: other! !

PPCompositeParserTest subclass: #PPSmalltalkGrammarTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitSmalltalk-Tests'!

!PPSmalltalkGrammarTests class methodsFor: 'accessing' stamp: 'lr 11/29/2010 11:36'!
packageNamesUnderTest
	^ #('PetitSmalltalk')! !

!PPSmalltalkGrammarTests methodsFor: 'accessing' stamp: 'lr 9/27/2009 12:42'!
parserClass
	^ PPSmalltalkGrammar! !

!PPSmalltalkGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testArgumentsBlock1
	self 
		parse: '[ :a | ]'
		rule: #block! !

!PPSmalltalkGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testArgumentsBlock2
	self 
		parse: '[ :a :b | ]'
		rule: #block! !

!PPSmalltalkGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testArgumentsBlock3
	self 
		parse: '[ :a :b :c | ]'
		rule: #block! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 3/1/2010 10:09'!
testArray1
	self 
		parse: '{}'
		rule: #array! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 3/1/2010 10:10'!
testArray2
	self 
		parse: '{self foo}'
		rule: #array! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 3/1/2010 10:10'!
testArray3
	self 
		parse: '{self foo. self bar}'
		rule: #array! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 3/1/2010 10:10'!
testArray4
	self 
		parse: '{self foo. self bar.}'
		rule: #array! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testArrayLiteral1
	self 
		parse: '#()'
		rule: #arrayLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testArrayLiteral10
	self 
		parse: '#((1 2) #(1 2 3))'
		rule: #arrayLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testArrayLiteral11
	self 
		parse: '#([1 2] #[1 2 3])'
		rule: #arrayLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testArrayLiteral2
	self 
		parse: '#(1)'
		rule: #arrayLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testArrayLiteral3
	self 
		parse: '#(1 2)'
		rule: #arrayLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testArrayLiteral4
	self 
		parse: '#(true false nil)'
		rule: #arrayLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testArrayLiteral5
	self 
		parse: '#($a)'
		rule: #arrayLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testArrayLiteral6
	self 
		parse: '#(1.2)'
		rule: #arrayLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testArrayLiteral7
	self 
		parse: '#(size #at: at:put: #''=='')'
		rule: #arrayLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testArrayLiteral8
	self 
		parse: '#(''baz'')'
		rule: #arrayLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'TestRunner 10/23/2009 16:52'!
testArrayLiteral9
	self 
		parse: '#((1) 2)'
		rule: #arrayLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testAssignment1
	self 
		parse: '1'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testAssignment2
	self 
		parse: 'a := 1'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testAssignment3
	self 
		parse: 'a := b := 1'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 7/11/2011 11:34'!
testAssignment4
	PPSmalltalkGrammar allowUnderscoreAssignment
		ifTrue: [ self parse: 'a _ 1' rule: #expression ]
		ifFalse: [ self fail: 'a _ 1' rule: #expression ]! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 7/11/2011 11:35'!
testAssignment5
	PPSmalltalkGrammar allowUnderscoreAssignment
		ifTrue: [ self parse: 'a _ b _ 1' rule: #expression ]
		ifFalse: [ self fail: 'a _ b _ 1' rule: #expression ]! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 11/23/2010 14:03'!
testAssignment6
	self 
		parse: 'a := (b := c)'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testBinaryExpression1
	self 
		parse: '1 + 2'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testBinaryExpression2
	self 
		parse: '1 + 2 + 3'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'DamienPollet 8/11/2011 22:20'!
testBinaryExpression3
	self 
		parse: '1 // 2'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 8/11/2011 23:28'!
testBinaryExpression4
	self 
		parse: '1 -- 2'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 8/11/2011 23:25'!
testBinaryExpression5
	self 
		parse: '1 ==> 2'
		rule: #expression.! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testBinaryMethod1
	self 
		parse: '+ a'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testBinaryMethod2
	self 
		parse: '+ a | b |'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testBinaryMethod3
	self 
		parse: '+ a b'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testBinaryMethod4
	self 
		parse: '+ a | b | c'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 8/11/2011 23:28'!
testBinaryMethod5
	self 
		parse: '-- a'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testByteLiteral1
	self 
		parse: '#[]'
		rule: #byteLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testByteLiteral2
	self 
		parse: '#[0]'
		rule: #byteLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testByteLiteral3
	self 
		parse: '#[255]'
		rule: #byteLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testByteLiteral4
	self 
		parse: '#[ 1 2 ]'
		rule: #byteLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testByteLiteral5
	self 
		parse: '#[ 2r1010 8r77 16rFF ]'
		rule: #byteLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testCascadeExpression1
	self 
		parse: '1 abs; negated'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testCascadeExpression2
	self 
		parse: '1 abs negated; raisedTo: 12; negated'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testCascadeExpression3
	self 
		parse: '1 + 2; - 3'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testCharLiteral1
	self 
		parse: '$a'
		rule: #charLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testCharLiteral2
	self 
		parse: '$ '
		rule: #charLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testCharLiteral3
	self 
		parse: '$$'
		rule: #charLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testComment1
	self 
		parse: '1"one"+2'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testComment2
	self 
		parse: '1 "one" +2'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testComment3
	self 
		parse: '1"one"+"two"2'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testComment4
	self 
		parse: '1"one""two"+2'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testComment5
	self 
		parse: '1"one"	"two"+2'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 8/17/2011 23:57'!
testCompleteness
	"This test asserts that all subclasses override all test methods."
	
	self class allSubclasses do: [ :subclass |
		self class testSelectors do: [ :selector |
			self 
				assert: (selector = #testCompleteness or: [ subclass selectors includes: selector ])
				description: subclass printString , ' does not test ' , selector printString ] ]! !

!PPSmalltalkGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testComplexBlock1
	self 
		parse: '[ :a | | b | c ]'
		rule: #block! !

!PPSmalltalkGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testComplexBlock2
	self 
		parse: '[:a||b|c]'
		rule: #block! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testKeywordExpression1
	self 
		parse: '1 to: 2'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testKeywordExpression2
	self 
		parse: '1 to: 2 by: 3'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testKeywordExpression3
	self 
		parse: '1 to: 2 by: 3 do: 4'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testKeywordMethod1
	self 
		parse: 'to: a'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testKeywordMethod2
	self 
		parse: 'to: a do: b | c |'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testKeywordMethod3
	self 
		parse: 'to: a do: b by: c d'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testKeywordMethod4
	self 
		parse: 'to: a do: b by: c | d | e'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testMethod1
	self 
		parse: 'negated ^ 0 - self'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testMethod2
	"Spaces at the beginning of the method."
	self 
		parse: '	  negated ^ 0 - self'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testMethod3
	"Spaces at the end of the method."
	self 
		parse: '	negated ^ 0 - self  '
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testNumberLiteral1
	self 
		parse: '0'
		rule: #numberLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testNumberLiteral10
	self 
		parse: '10r10'
		rule: #numberLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testNumberLiteral11
	self 
		parse: '8r777'
		rule: #numberLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testNumberLiteral12
	self 
		parse: '16rAF'
		rule: #numberLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testNumberLiteral13
	self 
		parse: '16rCA.FE'
		rule: #numberLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testNumberLiteral14
	self 
		parse: '3r-22.2'
		rule: #numberLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 8/13/2011 20:40'!
testNumberLiteral15
	self 
		parse: '0.50s2'
		rule: #numberLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testNumberLiteral2
	self 
		parse: '0.1'
		rule: #numberLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testNumberLiteral3
	self 
		parse: '123'
		rule: #numberLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testNumberLiteral4
	self 
		parse: '123.456'
		rule: #numberLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testNumberLiteral5
	self 
		parse: '-0'
		rule: #numberLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testNumberLiteral6
	self 
		parse: '-0.1'
		rule: #numberLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testNumberLiteral7
	self 
		parse: '-123'
		rule: #numberLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testNumberLiteral8
	self 
		parse: '-123'
		rule: #numberLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testNumberLiteral9
	self 
		parse: '-123.456'
		rule: #numberLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma1
	self 
		parse: 'method <foo>'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma10
	self 
		parse: 'method <foo: bar>'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma11
	self 
		parse: 'method <foo: true>'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma12
	self 
		parse: 'method <foo: false>'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma13
	self 
		parse: 'method <foo: nil>'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma14
	self 
		parse: 'method <foo: ()>'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 11/23/2010 13:59'!
testPragma15
	self 
		parse: 'method <foo: #()>'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 11/23/2010 13:59'!
testPragma16
	self 
		parse: 'method < + 1 >'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma2
	self 
		parse: 'method <foo> <bar>'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma3
	self 
		parse: 'method | a | <foo>'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma4
	self 
		parse: 'method <foo> | a |'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma5
	self 
		parse: 'method <foo> | a | <bar>'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma6
	self 
		parse: 'method <foo: 1>'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma7
	self 
		parse: 'method <foo: 1.2>'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma8
	self 
		parse: 'method <foo: ''bar''>'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma9
	self 
		parse: 'method <foo: #''bar''>'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testSequence1
	self 
		parse: '| a | 1 . 2'
		rule: #sequence! !

!PPSmalltalkGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testSimpleBlock1
	self 
		parse: '[ ]'
		rule: #block! !

!PPSmalltalkGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testSimpleBlock2
	self 
		parse: '[ nil ]'
		rule: #block! !

!PPSmalltalkGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testSimpleBlock3
	self 
		parse: '[ :a ]'
		rule: #block! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testSpecialLiteral1
	self 
		parse: 'true'
		rule: #trueLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testSpecialLiteral2
	self 
		parse: 'false'
		rule: #falseLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testSpecialLiteral3
	self 
		parse: 'nil'
		rule: #nilLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testStatementBlock1
	self 
		parse: '[ nil ]'
		rule: #block! !

!PPSmalltalkGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testStatementBlock2
	self 
		parse: '[ | a | nil ]'
		rule: #block! !

!PPSmalltalkGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testStatementBlock3
	self 
		parse: '[ | a b | nil ]'
		rule: #block! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testStatements1
	self 
		parse: '1'
		rule: #sequence! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testStatements2
	self 
		parse: '1 . 2'
		rule: #sequence! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testStatements3
	self 
		parse: '1 . 2 . 3'
		rule: #sequence! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testStatements4
	self 
		parse: '1 . 2 . 3 .'
		rule: #sequence! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testStatements5
	self 
		parse: '1 . . 2'
		rule: #sequence! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 8/13/2011 20:45'!
testStatements6
	self 
		parse: '1. 2'
		rule: #sequence! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 8/13/2011 20:46'!
testStatements7
	self 
		parse: '. 1'
		rule: #sequence! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 8/13/2011 20:46'!
testStatements8
	self 
		parse: '.1'
		rule: #sequence! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testStringLiteral1
	self 
		parse: ''''''
		rule: #stringLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testStringLiteral2
	self 
		parse: '''ab'''
		rule: #stringLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testStringLiteral3
	self 
		parse: '''ab''''cd'''
		rule: #stringLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testSymbolLiteral1
	self 
		parse: '#foo'
		rule: #symbolLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testSymbolLiteral2
	self 
		parse: '#+'
		rule: #symbolLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testSymbolLiteral3
	self 
		parse: '#key:'
		rule: #symbolLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testSymbolLiteral4
	self 
		parse: '#key:value:'
		rule: #symbolLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testSymbolLiteral5
	self 
		parse: '#''testing-result'''
		rule: #symbolLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 7/11/2011 11:41'!
testSymbolLiteral6
	PPSmalltalkGrammar allowUnderscoreAssignment ifFalse: [
		self 
			parse: '#__gen__binding'
			rule: #symbolLiteral ]! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 8/14/2011 12:26'!
testSymbolLiteral7
	self 
		parse: '# fucker'
		rule: #symbolLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 8/14/2011 12:26'!
testSymbolLiteral8
	self 
		parse: '##fucker'
		rule: #symbolLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 8/14/2011 12:26'!
testSymbolLiteral9
	self 
		parse: '## fucker'
		rule: #symbolLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testTemporaries1
	self 
		parse: '| a |'
		rule: #sequence! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testTemporaries2
	self 
		parse: '| a b |'
		rule: #sequence! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testTemporaries3
	self 
		parse: '| a b c |'
		rule: #sequence! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testUnaryExpression1
	self 
		parse: '1 abs'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testUnaryExpression2
	self 
		parse: '1 abs negated'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testUnaryMethod1
	self 
		parse: 'abs'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testUnaryMethod2
	self 
		parse: 'abs | a |'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testUnaryMethod3
	self 
		parse: 'abs a'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testUnaryMethod4
	self 
		parse: 'abs | a | b'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testUnaryMethod5
	self 
		parse: 'abs | a |'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testVariable1
	self 
		parse: 'trueBinding'
		rule: #primary! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testVariable2
	self 
		parse: 'falseBinding'
		rule: #primary! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testVariable3
	self 
		parse: 'nilly'
		rule: #primary! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testVariable4
	self 
		parse: 'selfish'
		rule: #primary! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testVariable5
	self 
		parse: 'supernanny'
		rule: #primary! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 7/11/2011 11:41'!
testVariable6
	PPSmalltalkGrammar allowUnderscoreAssignment ifFalse: [
		self 
			parse: 'super_nanny'
			rule: #primary ]! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 7/11/2011 11:41'!
testVariable7
	PPSmalltalkGrammar allowUnderscoreAssignment ifFalse: [
		self 
			parse: '__gen_var_123__'
			rule: #primary ]! !

PPSmalltalkGrammarTests subclass: #PPSmalltalkParserTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitSmalltalk-Tests'!

!PPSmalltalkParserTests methodsFor: 'private' stamp: 'lr 3/29/2010 15:31'!
assert: aNode format: aString 
	aNode isCollection 
		ifFalse: [ ^ self assert: (Array with: aNode) format: (Array with: aString) ].
	self assert: aNode size = aString size.
	aNode
		with: aString
		do: [ :node :string | self assert: (RBFormatter new format: node) withBlanksTrimmed = string ]! !

!PPSmalltalkParserTests methodsFor: 'accessing' stamp: 'lr 12/7/2009 09:01'!
parserClass
	^ PPSmalltalkParser! !

!PPSmalltalkParserTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testArgumentsBlock1
	super testArgumentsBlock1.
	self assert: result isBlock.
	self assert: result arguments size = 1.
	self assert: result arguments first isVariable.
	self assert: result arguments first name = 'a'.
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testArgumentsBlock2
	super testArgumentsBlock2.
	self assert: result isBlock.
	self assert: result arguments size = 2.
	self assert: result arguments first isVariable.
	self assert: result arguments first name = 'a'.
	self assert: result arguments second isVariable.
	self assert: result arguments second name = 'b'.
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testArgumentsBlock3
	super testArgumentsBlock3.
	self assert: result isBlock.
	self assert: result arguments size = 3.
	self assert: result arguments first isVariable.
	self assert: result arguments first name = 'a'.
	self assert: result arguments second isVariable.
	self assert: result arguments second name = 'b'.
	self assert: result arguments third isVariable.
	self assert: result arguments third name = 'c'.
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 3/1/2010 10:13'!
testArray1
	super testArray1.
	self assert: result isArray.
	self assert: result statements isEmpty.
	self assert: result periods isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 3/1/2010 10:13'!
testArray2
	super testArray2.
	self assert: result isArray.
	self assert: result periods isEmpty.
	self assert: result statements size = 1.
	self assert: result statements first isMessage.
	self assert: result statements first selector = #foo! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 3/1/2010 10:14'!
testArray3
	super testArray3.
	self assert: result isArray.
	self assert: result periods size = 1.
	self assert: result statements size = 2.
	self assert: result statements first isMessage.
	self assert: result statements first selector = #foo.
	self assert: result statements last isMessage.
	self assert: result statements last selector = #bar! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 3/1/2010 10:14'!
testArray4
	super testArray4.
	self assert: result isArray.
	self assert: result periods size = 2.
	self assert: result statements size = 2.
	self assert: result statements first isMessage.
	self assert: result statements first selector = #foo.
	self assert: result statements last isMessage.
	self assert: result statements last selector = #bar! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testArrayLiteral1
	super testArrayLiteral1.
	self assert: result isLiteral.
	self assert: result value = #()! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testArrayLiteral10
	super testArrayLiteral10.
	self assert: result isLiteral.
	self assert: result value = #(#(1 2 ) #(1 2 3 ) )! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testArrayLiteral11
	super testArrayLiteral11.
	self assert: result isLiteral.
	self assert: result value size = 2.
	self assert: (result value first isKindOf: ByteArray).
	self assert: result value first size = 2.
	self assert: (result value last isKindOf: ByteArray).
	self assert: result value last size = 3! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TestRunner 10/23/2009 17:44'!
testArrayLiteral2
	super testArrayLiteral2.
	self assert: result isLiteral.
	self assert: result value = #(1)! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testArrayLiteral3
	super testArrayLiteral3.
	self assert: result isLiteral.
	self assert: result value = #(1 2 )! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testArrayLiteral4
	super testArrayLiteral4.
	self assert: result isLiteral.
	self assert: result value = #(true false nil )! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testArrayLiteral5
	super testArrayLiteral5.
	self assert: result isLiteral.
	self assert: result value = #($a )! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testArrayLiteral6
	super testArrayLiteral6.
	self assert: result isLiteral.
	self assert: result value = #(1.2 )! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testArrayLiteral7
	super testArrayLiteral7.
	self assert: result isLiteral.
	self assert: result value = #(#size #at: #at:put: #'==' ).
	result value do: [ :each | self assert: each isSymbol ]! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testArrayLiteral8
	super testArrayLiteral8.
	self assert: result isLiteral.
	self assert: result value = #('baz' ).
	self assert: result value first isString.
	self assert: result value first isSymbol not! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testArrayLiteral9
	super testArrayLiteral9.
	self assert: result isLiteral.
	self assert: result value = #(#(1 ) 2 )! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testAssignment1
	super testAssignment1.
	self assert: result isLiteral.
	self assert: result value = 1! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testAssignment2
	super testAssignment2.
	self assert: result isAssignment.
	self assert: result variable isVariable.
	self assert: result variable name = 'a'.
	self assert: result value isLiteral.
	self assert: result value value = 1! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testAssignment3
	super testAssignment3.
	self assert: result isAssignment.
	self assert: result variable isVariable.
	self assert: result variable name = 'a'.
	self assert: result value isAssignment.
	self assert: result value variable isVariable.
	self assert: result value variable name = 'b'.
	self assert: result value value isLiteral.
	self assert: result value value value = 1! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 8/14/2011 11:35'!
testAssignment4
	super testAssignment4.
	PPSmalltalkGrammar allowUnderscoreAssignment
		ifFalse: [ ^ self ].
	self assert: result isAssignment.
	self assert: result variable isVariable.
	self assert: result variable name = 'a'.
	self assert: result value isLiteral.
	self assert: result value value = 1! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 8/14/2011 11:35'!
testAssignment5
	super testAssignment5.
	PPSmalltalkGrammar allowUnderscoreAssignment
		ifFalse: [ ^ self ].
	self assert: result isAssignment.
	self assert: result variable isVariable.
	self assert: result variable name = 'a'.
	self assert: result value isAssignment.
	self assert: result value variable isVariable.
	self assert: result value variable name = 'b'.
	self assert: result value value isLiteral.
	self assert: result value value value = 1! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 11/23/2010 14:02'!
testAssignment6
	super testAssignment6.
	self assert: result isAssignment.
	self assert: result variable isVariable.
	self assert: result variable name = 'a'.
	self assert: result value isAssignment.
	self assert: result value variable isVariable.
	self assert: result value variable name = 'b'.
	self assert: result value value isVariable.
	self assert: result value value name = 'c'! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testBinaryExpression1
	super testBinaryExpression1.
	self assert: result isMessage.
	self assert: result receiver isLiteral.
	self assert: result receiver value = 1.
	self assert: result arguments size = 1.
	self assert: result arguments first isLiteral.
	self assert: result arguments first value = 2! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testBinaryExpression2
	super testBinaryExpression2.
	self assert: result isMessage.
	self assert: result receiver isMessage.
	self assert: result receiver receiver isLiteral.
	self assert: result receiver receiver value = 1.
	self assert: result receiver arguments size = 1.
	self assert: result receiver arguments first isLiteral.
	self assert: result receiver arguments first value = 2.
	self assert: result arguments size = 1.
	self assert: result arguments first isLiteral.
	self assert: result arguments first value = 3! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'lr 8/11/2011 23:27'!
testBinaryExpression3
	super testBinaryExpression3.
	self assert: result isMessage.
	self assert: result receiver isLiteral.
	self assert: result receiver value = 1.
	self assert: result selector = #//.
	self assert: result arguments size = 1.
	self assert: result arguments first isLiteral.
	self assert: result arguments first value = 2! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'lr 8/11/2011 23:28'!
testBinaryExpression4
	super testBinaryExpression4.
	self assert: result isMessage.
	self assert: result receiver isLiteral.
	self assert: result receiver value = 1.
	self assert: result selector = #--.
	self assert: result arguments size = 1.
	self assert: result arguments first isLiteral.
	self assert: result arguments first value = 2! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'lr 8/11/2011 23:27'!
testBinaryExpression5
	super testBinaryExpression5.
	self assert: result isMessage.
	self assert: result receiver isLiteral.
	self assert: result receiver value = 1.
	self assert: result selector = #==>.
	self assert: result arguments size = 1.
	self assert: result arguments first isLiteral.
	self assert: result arguments first value = 2! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testBinaryMethod1
	super testBinaryMethod1.
	self assert: result isMethod.
	self assert: result selector = #+.
	self assert: result arguments size = 1.
	self assert: result arguments first isVariable.
	self assert: result arguments first name = 'a'.
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testBinaryMethod2
	super testBinaryMethod2.
	self assert: result isMethod.
	self assert: result selector = #+.
	self assert: result arguments size = 1.
	self assert: result arguments first isVariable.
	self assert: result arguments first name = 'a'.
	self assert: result body temporaries size = 1.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testBinaryMethod3
	super testBinaryMethod3.
	self assert: result isMethod.
	self assert: result selector = #+.
	self assert: result arguments size = 1.
	self assert: result arguments first isVariable.
	self assert: result arguments first name = 'a'.
	self assert: result body temporaries isEmpty.
	self assert: result body statements size = 1! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testBinaryMethod4
	super testBinaryMethod4.
	self assert: result isMethod.
	self assert: result selector = #+.
	self assert: result arguments size = 1.
	self assert: result arguments first isVariable.
	self assert: result arguments first name = 'a'.
	self assert: result body temporaries size = 1.
	self assert: result body statements size = 1! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'lr 8/11/2011 23:29'!
testBinaryMethod5
	super testBinaryMethod5.
	self assert: result isMethod.
	self assert: result selector = #--.
	self assert: result arguments size = 1.
	self assert: result arguments first isVariable.
	self assert: result arguments first name = 'a'.
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testByteLiteral1
	super testByteLiteral1.
	self assert: result isLiteral.
	self assert: (result value isKindOf: ByteArray).
	self assert: result value isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testByteLiteral2
	super testByteLiteral2.
	self assert: result isLiteral.
	self assert: (result value isKindOf: ByteArray).
	self assert: result value size = 1.
	self assert: result value first = 0! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testByteLiteral3
	super testByteLiteral3.
	self assert: result isLiteral.
	self assert: (result value isKindOf: ByteArray).
	self assert: result value size = 1.
	self assert: result value first = 255! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testByteLiteral4
	super testByteLiteral4.
	self assert: result isLiteral.
	self assert: (result value isKindOf: ByteArray).
	self assert: result value size = 2.
	self assert: result value first = 1.
	self assert: result value last = 2! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testByteLiteral5
	super testByteLiteral5.
	self assert: result isLiteral.
	self assert: (result value isKindOf: ByteArray).
	self assert: result value size = 3.
	self assert: result value first = 10.
	self assert: result value second = 63.
	self assert: result value last = 255! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testCascadeExpression1
	super testCascadeExpression1.
	self assert: result isCascade.
	self assert: result receiver isLiteral.
	self assert: result messages size = 2.
	self assert: result messages first receiver = result receiver.
	self assert: result messages first selector = #abs.
	self assert: result messages second receiver = result receiver.
	self assert: result messages second selector = #negated! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testCascadeExpression2
	super testCascadeExpression2.
	self assert: result isCascade.
	self assert: result receiver isMessage.
	self assert: result receiver receiver isLiteral.
	self assert: result receiver receiver value = 1.
	self assert: result receiver selector = #abs.
	self assert: result messages size = 3.
	self assert: result messages first receiver = result receiver.
	self assert: result messages first selector = #negated.
	self assert: result messages second receiver = result receiver.
	self assert: result messages second selector = #raisedTo:.
	self assert: result messages third receiver = result receiver.
	self assert: result messages third selector = #negated! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testCascadeExpression3
	super testCascadeExpression3.
	self assert: result isCascade.
	self assert: result receiver isLiteral.
	self assert: result receiver value = 1.
	self assert: result messages size = 2.
	self assert: result messages first receiver = result receiver.
	self assert: result messages first selector = #+.
	self assert: result messages first arguments size = 1.
	self assert: result messages second receiver = result receiver.
	self assert: result messages second selector = #-.
	self assert: result messages second arguments size = 1! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testCharLiteral1
	super testCharLiteral1.
	self assert: result isLiteral.
	self assert: result value = $a! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testCharLiteral2
	super testCharLiteral2.
	self assert: result isLiteral.
	self assert: result value = Character space! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testCharLiteral3
	super testCharLiteral3.
	self assert: result isLiteral.
	self assert: result value = $$! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 3/1/2010 10:20'!
testComment1
	super testComment1.
	self assert: result isMessage.
	self assert: result receiver isValue.
	self assert: result selector = #+.
	self assert: result arguments first isValue! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testComment2
	super testComment2.
	self assert: result isMessage.
	self assert: result receiver isValue.
	self assert: result selector = #+.
	self assert: result arguments first isValue! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testComment3
	super testComment3.
	self assert: result isMessage.
	self assert: result receiver isValue.
	self assert: result selector = #+.
	self assert: result arguments first isValue! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testComment4
	super testComment4.
	self assert: result isMessage.
	self assert: result receiver isValue.
	self assert: result selector = #+.
	self assert: result arguments first isValue! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testComment5
	super testComment5.
	self assert: result isMessage.
	self assert: result receiver isValue.
	self assert: result selector = #+.
	self assert: result arguments first isValue! !

!PPSmalltalkParserTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testComplexBlock1
	super testComplexBlock1.
	self assert: result isBlock.
	self assert: result arguments size = 1.
	self assert: result body temporaries size = 1.
	self assert: result body statements size = 1! !

!PPSmalltalkParserTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testComplexBlock2
	super testComplexBlock2.
	self assert: result isBlock.
	self assert: result arguments size = 1.
	self assert: result body temporaries size = 1.
	self assert: result body statements size = 1! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testKeywordExpression1
	super testKeywordExpression1.
	self assert: result isMessage.
	self assert: result receiver isLiteral.
	self assert: result receiver value = 1.
	self assert: result selector = #to:.
	self assert: result arguments size = 1.
	self assert: result arguments first isLiteral.
	self assert: result arguments first value = 2! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testKeywordExpression2
	super testKeywordExpression2.
	self assert: result isMessage.
	self assert: result receiver isLiteral.
	self assert: result selector = #to:by:.
	self assert: result arguments size = 2.
	self assert: result arguments first isLiteral.
	self assert: result arguments first value = 2.
	self assert: result arguments second isLiteral.
	self assert: result arguments second value = 3! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testKeywordExpression3
	super testKeywordExpression3.
	self assert: result isMessage.
	self assert: result receiver isLiteral.
	self assert: result selector = #to:by:do:.
	self assert: result arguments size = 3.
	self assert: result arguments first isLiteral.
	self assert: result arguments first value = 2.
	self assert: result arguments second isLiteral.
	self assert: result arguments second value = 3.
	self assert: result arguments third isLiteral.
	self assert: result arguments third value = 4! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testKeywordMethod1
	super testKeywordMethod1.
	self assert: result isMethod.
	self assert: result selector = #to:.
	self assert: result arguments size = 1.
	self assert: result arguments first isVariable.
	self assert: result arguments first name = 'a'.
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testKeywordMethod2
	super testKeywordMethod2.
	self assert: result isMethod.
	self assert: result selector = #to:do:.
	self assert: result arguments size = 2.
	self assert: result arguments first isVariable.
	self assert: result arguments first name = 'a'.
	self assert: result arguments second isVariable.
	self assert: result arguments second name = 'b'.
	self assert: result body temporaries size = 1.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testKeywordMethod3
	super testKeywordMethod3.
	self assert: result isMethod.
	self assert: result selector = #to:do:by:.
	self assert: result arguments size = 3.
	self assert: result arguments first isVariable.
	self assert: result arguments first name = 'a'.
	self assert: result arguments second isVariable.
	self assert: result arguments second name = 'b'.
	self assert: result arguments third isVariable.
	self assert: result arguments third name = 'c'.
	self assert: result body temporaries isEmpty.
	self assert: result body statements size = 1! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testKeywordMethod4
	super testKeywordMethod4.
	self assert: result isMethod.
	self assert: result selector = #to:do:by:.
	self assert: result arguments size = 3.
	self assert: result arguments first isVariable.
	self assert: result arguments first name = 'a'.
	self assert: result arguments second isVariable.
	self assert: result arguments second name = 'b'.
	self assert: result arguments third isVariable.
	self assert: result arguments third name = 'c'.
	self assert: result body temporaries size = 1.
	self assert: result body statements size = 1! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testMethod1
	super testMethod1.
	self assert: result isMethod.
	self assert: result arguments isEmpty.
	self assert: result body temporaries isEmpty.
	self assert: result body statements size = 1.
	self assert: result body statements first isReturn.
	self assert: result body statements first value isMessage.
	self assert: result body statements first value receiver isLiteral.
	self assert: result body statements first value selector = #-.
	self assert: result body statements first value arguments size = 1.
	self assert: result body statements first value arguments first isVariable! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testMethod2
	super testMethod2.
	self assert: result isMethod.
	self assert: result arguments isEmpty.
	self assert: result body temporaries isEmpty.
	self assert: result body statements size = 1.
	self assert: result body statements first isReturn.
	self assert: result body statements first value isMessage.
	self assert: result body statements first value receiver isLiteral.
	self assert: result body statements first value selector = #-.
	self assert: result body statements first value arguments size = 1.
	self assert: result body statements first value arguments first isVariable! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testMethod3
	super testMethod3.
	self assert: result isMethod.
	self assert: result arguments isEmpty.
	self assert: result body temporaries isEmpty.
	self assert: result body statements size = 1.
	self assert: result body statements first isReturn.
	self assert: result body statements first value isMessage.
	self assert: result body statements first value receiver isLiteral.
	self assert: result body statements first value selector = #-.
	self assert: result body statements first value arguments size = 1.
	self assert: result body statements first value arguments first isVariable! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 8/14/2011 12:48'!
testNumberLiteral1
	super testNumberLiteral1.
	self assert: result isLiteral.
	self assert: result value = 0.
	self assert: result value isInteger! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 8/14/2011 12:48'!
testNumberLiteral10
	super testNumberLiteral10.
	self assert: result isLiteral.
	self assert: result value = 10.
	self assert: result value isInteger! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 8/14/2011 12:48'!
testNumberLiteral11
	super testNumberLiteral11.
	self assert: result isLiteral.
	self assert: result value = 511.
	self assert: result value isInteger! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 8/14/2011 12:48'!
testNumberLiteral12
	super testNumberLiteral12.
	self assert: result isLiteral.
	self assert: result value = 175.
	self assert: result value isInteger! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 8/14/2011 12:48'!
testNumberLiteral13
	super testNumberLiteral13.
	self assert: result isLiteral.
	self assert: result value = 202.9921875.
	self assert: result value isFloat! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 8/14/2011 12:50'!
testNumberLiteral14
	super testNumberLiteral14.
	self assert: result isLiteral.
	self assert: result value floor = -9.
	self assert: result value isFloat! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 8/14/2011 12:49'!
testNumberLiteral15
	super testNumberLiteral15.
	self assert: result isLiteral.
	self assert: result value = (1 / 2)! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 8/14/2011 12:49'!
testNumberLiteral2
	super testNumberLiteral2.
	self assert: result isLiteral.
	self assert: result value = 0.1.
	self assert: result value isFloat! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 8/14/2011 12:50'!
testNumberLiteral3
	super testNumberLiteral3.
	self assert: result isLiteral.
	self assert: result value = 123.
	self assert: result value isInteger! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 8/14/2011 12:50'!
testNumberLiteral4
	super testNumberLiteral4.
	self assert: result isLiteral.
	self assert: result value = 123.456.
	self assert: result value isFloat! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 8/14/2011 12:50'!
testNumberLiteral5
	super testNumberLiteral5.
	self assert: result isLiteral.
	self assert: result value = 0.
	self assert: result value isInteger! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 8/14/2011 12:50'!
testNumberLiteral6
	super testNumberLiteral6.
	self assert: result isLiteral.
	self assert: result value = -0.1.
	self assert: result value isFloat! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 8/14/2011 12:50'!
testNumberLiteral7
	super testNumberLiteral7.
	self assert: result isLiteral.
	self assert: result value = -123.
	self assert: result value isInteger! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 8/14/2011 12:50'!
testNumberLiteral8
	super testNumberLiteral8.
	self assert: result isLiteral.
	self assert: result value = -123.
	self assert: result value isInteger! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 8/14/2011 12:50'!
testNumberLiteral9
	super testNumberLiteral9.
	self assert: result isLiteral.
	self assert: result value = -123.456.
	self assert: result value isFloat! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma1
	super testPragma1.
	self 
		assert: result pragmas
		format: #('<foo>' ).
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma10
	super testPragma10.
	self 
		assert: result pragmas
		format: #('<foo: #bar>' ).
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma11
	super testPragma11.
	self 
		assert: result pragmas
		format: #('<foo: true>' ).
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma12
	super testPragma12.
	self 
		assert: result pragmas
		format: #('<foo: false>' ).
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma13
	super testPragma13.
	self 
		assert: result pragmas
		format: #('<foo: nil>' ).
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma14
	super testPragma14.
	self 
		assert: result pragmas
		format: #('<foo: #()>' ).
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma15
	super testPragma15.
	self 
		assert: result pragmas
		format: #('<foo: #()>' ).
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'lr 11/23/2010 14:07'!
testPragma16
	super testPragma16.
	self 
		assert: result pragmas
		format: #('< + 1>' ).
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma2
	super testPragma2.
	self 
		assert: result pragmas
		format: #('<foo>' '<bar>' ).
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma3
	super testPragma3.
	self 
		assert: result pragmas
		format: #('<foo>' ).
	self assert: result body temporaries size = 1.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma4
	super testPragma4.
	self 
		assert: result pragmas
		format: #('<foo>' ).
	self assert: result body temporaries size = 1.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma5
	super testPragma5.
	self 
		assert: result pragmas
		format: #('<foo>' '<bar>' ).
	self assert: result body temporaries size = 1.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma6
	super testPragma6.
	self 
		assert: result pragmas
		format: #('<foo: 1>' ).
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma7
	super testPragma7.
	self 
		assert: result pragmas
		format: #('<foo: 1.2>' ).
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma8
	super testPragma8.
	self 
		assert: result pragmas
		format: #('<foo: ''bar''>' ).
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma9
	super testPragma9.
	self 
		assert: result pragmas
		format: #('<foo: #bar>' ).
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testSequence1
	super testSequence1.
	self assert: result isSequence.
	self assert: result temporaries size = 1.
	self assert: result temporaries first isVariable.
	self assert: result temporaries first name = 'a'.
	self assert: result statements size = 2.
	self assert: result statements first isLiteral.
	self assert: result statements first value = 1.
	self assert: result statements second isLiteral.
	self assert: result statements second value = 2! !

!PPSmalltalkParserTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testSimpleBlock1
	super testSimpleBlock1.
	self assert: result isBlock.
	self assert: result arguments isEmpty.
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testSimpleBlock2
	super testSimpleBlock2.
	self assert: result isBlock.
	self assert: result arguments isEmpty.
	self assert: result body temporaries isEmpty.
	self assert: result body statements size = 1! !

!PPSmalltalkParserTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testSimpleBlock3
	super testSimpleBlock3.
	self assert: result isBlock.
	self assert: result arguments size = 1.
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testSpecialLiteral1
	super testSpecialLiteral1.
	self assert: result isLiteral.
	self assert: result value = true! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testSpecialLiteral2
	super testSpecialLiteral2.
	self assert: result isLiteral.
	self assert: result value = false! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testSpecialLiteral3
	super testSpecialLiteral3.
	self assert: result isLiteral.
	self assert: result value = nil! !

!PPSmalltalkParserTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testStatementBlock1
	super testStatementBlock1.
	self assert: result isBlock.
	self assert: result arguments isEmpty.
	self assert: result body temporaries isEmpty.
	self assert: result body statements size = 1! !

!PPSmalltalkParserTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testStatementBlock2
	super testStatementBlock2.
	self assert: result isBlock.
	self assert: result arguments isEmpty.
	self assert: result body temporaries size = 1.
	self assert: result body statements size = 1! !

!PPSmalltalkParserTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testStatementBlock3
	super testStatementBlock3.
	self assert: result isBlock.
	self assert: result arguments isEmpty.
	self assert: result body temporaries size = 2.
	self assert: result body statements size = 1! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 8/13/2011 20:50'!
testStatements1
	super testStatements1.
	self assert: result isSequence.
	self assert: result temporaries isEmpty.
	self assert: result statements size = 1.
	self assert: result statements first isLiteral.
	self assert: result statements first value = 1.
	self assert: result statements first value isInteger! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 8/13/2011 20:50'!
testStatements2
	super testStatements2.
	self assert: result isSequence.
	self assert: result temporaries isEmpty.
	self assert: result statements size = 2.
	self assert: result statements first isLiteral.
	self assert: result statements first value = 1.
	self assert: result statements first value isInteger.
	self assert: result statements second isLiteral.
	self assert: result statements second value = 2.
	self assert: result statements second value isInteger! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 8/13/2011 20:50'!
testStatements3
	super testStatements3.
	self assert: result isSequence.
	self assert: result temporaries isEmpty.
	self assert: result statements size = 3.
	self assert: result statements first isLiteral.
	self assert: result statements first value = 1.
	self assert: result statements first value isInteger.
	self assert: result statements second isLiteral.
	self assert: result statements second value = 2.
	self assert: result statements second value isInteger.
	self assert: result statements third isLiteral.
	self assert: result statements third value = 3.
	self assert: result statements third value isInteger! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 8/13/2011 20:49'!
testStatements4
	super testStatements4.
	self assert: result isSequence.
	self assert: result temporaries isEmpty.
	self assert: result statements size = 3.
	self assert: result statements first isLiteral.
	self assert: result statements first value = 1.
	self assert: result statements first value isInteger.
	self assert: result statements second isLiteral.
	self assert: result statements second value = 2.
	self assert: result statements second value isInteger.
	self assert: result statements third isLiteral.
	self assert: result statements third value = 3.
	self assert: result statements third value isInteger! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 8/13/2011 20:49'!
testStatements5
	super testStatements5.
	self assert: result isSequence.
	self assert: result temporaries isEmpty.
	self assert: result statements size = 2.
	self assert: result statements first isLiteral.
	self assert: result statements first value = 1.
	self assert: result statements first value isInteger.
	self assert: result statements second isLiteral.
	self assert: result statements second value = 2.
	self assert: result statements second value isInteger! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 8/13/2011 20:49'!
testStatements6
	super testStatements6.
	self assert: result isSequence.
	self assert: result temporaries isEmpty.
	self assert: result statements size = 2.
	self assert: result statements first isLiteral.
	self assert: result statements first value = 1.
	self assert: result statements first value isInteger.
	self assert: result statements second isLiteral.
	self assert: result statements second value = 2.
	self assert: result statements second value isInteger
	! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 8/13/2011 21:21'!
testStatements7
	super testStatements7.
	self assert: result isSequence.
	self assert: result temporaries isEmpty.
	self assert: result statements size = 1.
	self assert: result statements first isLiteral.
	self assert: result statements first value = 1.
	self assert: result statements first value isInteger! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 8/13/2011 21:21'!
testStatements8
	super testStatements8.
	self assert: result isSequence.
	self assert: result temporaries isEmpty.
	self assert: result statements size = 1.
	self assert: result statements first isLiteral.
	self assert: result statements first value = 1.
	self assert: result statements first value isInteger! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testStringLiteral1
	super testStringLiteral1.
	self assert: result isLiteral.
	self assert: result value = ''! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testStringLiteral2
	super testStringLiteral2.
	self assert: result isLiteral.
	self assert: result value = 'ab'! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testStringLiteral3
	super testStringLiteral3.
	self assert: result isLiteral.
	self assert: result value = 'ab''cd'! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 8/14/2011 12:47'!
testSymbolLiteral1
	super testSymbolLiteral1.
	self assert: result isLiteral.
	self assert: result value = #foo.
	self assert: result value isSymbol! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 8/14/2011 12:47'!
testSymbolLiteral2
	super testSymbolLiteral2.
	self assert: result isLiteral.
	self assert: result value = #+.
	self assert: result value isSymbol! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 8/14/2011 12:47'!
testSymbolLiteral3
	super testSymbolLiteral3.
	self assert: result isLiteral.
	self assert: result value = #key:.
	self assert: result value isSymbol! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 8/14/2011 12:47'!
testSymbolLiteral4
	super testSymbolLiteral4.
	self assert: result isLiteral.
	self assert: result value = #key:value:.
	self assert: result value isSymbol! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 8/14/2011 12:47'!
testSymbolLiteral5
	super testSymbolLiteral5.
	self assert: result isLiteral.
	self assert: result value = #'testing-result'.
	self assert: result value isSymbol! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 8/14/2011 12:47'!
testSymbolLiteral6
	super testSymbolLiteral6.
	PPSmalltalkGrammar allowUnderscoreAssignment
		ifTrue: [ ^ self ].
	self assert: result isLiteral.
	self assert: result value = #__gen__binding.
	self assert: result value isSymbol! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 8/14/2011 12:47'!
testSymbolLiteral7
	super testSymbolLiteral7.
	self assert: result isLiteral.
	self assert: result value = #fucker.
	self assert: result value isSymbol! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 8/14/2011 12:47'!
testSymbolLiteral8
	super testSymbolLiteral8.
	self assert: result isLiteral.
	self assert: result value = #fucker.
	self assert: result value isSymbol! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'lr 8/14/2011 12:47'!
testSymbolLiteral9
	super testSymbolLiteral9.
	self assert: result isLiteral.
	self assert: result value = #fucker.
	self assert: result value isSymbol! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testTemporaries1
	super testTemporaries1.
	self assert: result isSequence.
	self assert: result temporaries size = 1.
	self assert: result temporaries first isVariable.
	self assert: result temporaries first name = 'a'.
	self assert: result statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testTemporaries2
	super testTemporaries2.
	self assert: result isSequence.
	self assert: result temporaries size = 2.
	self assert: result temporaries first isVariable.
	self assert: result temporaries first name = 'a'.
	self assert: result temporaries second isVariable.
	self assert: result temporaries second name = 'b'.
	self assert: result statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testTemporaries3
	super testTemporaries3.
	self assert: result isSequence.
	self assert: result temporaries size = 3.
	self assert: result temporaries first isVariable.
	self assert: result temporaries first name = 'a'.
	self assert: result temporaries second isVariable.
	self assert: result temporaries second name = 'b'.
	self assert: result temporaries third isVariable.
	self assert: result temporaries third name = 'c'.
	self assert: result statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testUnaryExpression1
	super testUnaryExpression1.
	self assert: result isMessage.
	self assert: result receiver isLiteral.
	self assert: result selector = #abs.
	self assert: result arguments isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testUnaryExpression2
	super testUnaryExpression2.
	self assert: result isMessage.
	self assert: result receiver isMessage.
	self assert: result receiver receiver isLiteral.
	self assert: result receiver receiver value = 1.
	self assert: result receiver selector = #abs.
	self assert: result receiver arguments isEmpty.
	self assert: result selector = #negated.
	self assert: result arguments isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testUnaryMethod1
	super testUnaryMethod1.
	self assert: result isMethod.
	self assert: result selector = #abs.
	self assert: result arguments isEmpty.
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testUnaryMethod2
	super testUnaryMethod2.
	self assert: result isMethod.
	self assert: result selector = #abs.
	self assert: result arguments isEmpty.
	self assert: result body temporaries size = 1.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testUnaryMethod3
	super testUnaryMethod3.
	self assert: result isMethod.
	self assert: result selector = #abs.
	self assert: result arguments isEmpty.
	self assert: result body temporaries isEmpty.
	self assert: result body statements size = 1! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testUnaryMethod4
	super testUnaryMethod4.
	self assert: result isMethod.
	self assert: result selector = #abs.
	self assert: result arguments isEmpty.
	self assert: result body temporaries size = 1.
	self assert: result body statements size = 1! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testUnaryMethod5
	super testUnaryMethod5.
	self assert: result isMethod.
	self assert: result selector = #abs.
	self assert: result arguments isEmpty.
	self assert: result body temporaries size = 1.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testVariable1
	super testVariable1.
	self assert: result isVariable.
	self assert: result name = 'trueBinding'! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testVariable2
	super testVariable2.
	self assert: result isVariable.
	self assert: result name = 'falseBinding'! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testVariable3
	super testVariable3.
	self assert: result isVariable.
	self assert: result name = 'nilly'! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testVariable4
	super testVariable4.
	self assert: result isVariable.
	self assert: result name = 'selfish'! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testVariable5
	super testVariable5.
	self assert: result isVariable.
	self assert: result name = 'supernanny'! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 8/14/2011 11:35'!
testVariable6
	super testVariable6.
	PPSmalltalkGrammar allowUnderscoreAssignment
		ifTrue: [ ^ self ].
	self assert: result isVariable.
	self assert: result name = 'super_nanny'! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 8/14/2011 11:35'!
testVariable7
	super testVariable7.
	PPSmalltalkGrammar allowUnderscoreAssignment
		ifTrue: [ ^ self ].
	self assert: result isVariable.
	self assert: result name = '__gen_var_123__'! !

PPCompositeParserTest subclass: #PPSmalltalkNumberGrammarTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitSmalltalk-Tests'!

!PPSmalltalkNumberGrammarTests methodsFor: 'accessing' stamp: 'fbs 8/12/2011 18:30'!
parserClass
	^ PPSmalltalkNumberGrammar.! !

!PPSmalltalkNumberGrammarTests methodsFor: 'test - grammar' stamp: 'fbs 9/7/2011 21:09'!
testIntegersParse
	| digits |
	#('1' '0' '-0' '-1' '255' '9876543210' '1e10' '1e+10') do: [:each |
		self parse: each rule: #decimalNumber].
	#('1' '0' '-0' '-1' '255' '9876543210' '2r1' '2r-10' '-2r-10' '16rff' '36rzxy' '1e10' '2r1e26') do: [:each |
		self parse: each rule: #number].

	#('--1' '2r' '2rr' '3rr2' '2c1' '37r22' '1r0') do: [:each |
		self fail: each rule: #number].
	
	digits := '0123456789abcdefghijklmnopqrstuvwxyz'.
	2 to: 36 do: [:radix | | testCase |
		testCase := '{1}r{2}' format: {radix printString. (digits at: radix) printString}.
		self fail: testCase rule: #number].! !

!PPSmalltalkNumberGrammarTests methodsFor: 'test - grammar' stamp: 'fbs 9/3/2011 22:16'!
testPlainFloatsParse
	#('1.0' '0.0' '-0.0' '-1.0' '1e10' '1.0e10' '1.0e-10' '1.0e+10' '1d10' '1q10') do: [:each |
		self parse: each rule: #number].
	
	#('--1' '1..0' '1f10') do: [:each |
		self fail: each rule: #number]! !

!PPSmalltalkNumberGrammarTests methodsFor: 'test - grammar' stamp: 'fbs 9/6/2011 17:42'!
testRationalsParse
	self parse: '1e-10' rule: #number.! !

!PPSmalltalkNumberGrammarTests methodsFor: 'test - grammar' stamp: 'fbs 8/15/2011 21:13'!
testScaledDecimalsParse
	#('1s1' '10r2s2' '3r2s2' '1.2s2' '10r2.2s2' '2r10.101s2') do: [:each |
		self parse: each rule: #number].! !

!PPSmalltalkNumberGrammarTests methodsFor: 'test - grammar' stamp: 'fbs 9/6/2011 17:39'!
testScaledFloatsDoNotParse
	self fail: '9r-1.2e-3s4' rule: #number.! !

!PPSmalltalkNumberGrammarTests methodsFor: 'test - grammar' stamp: 'fbs 8/19/2011 07:48'!
testSpecificRadixFloatsParse
	#('2r1.0' '2r1.0101e9' '2r1e-10' '36rxyzzy.quux' '3r12.21e44' '16r1.0ea' "$e is a valid hex digit") do: [:each |
		self parse: each rule: #number].
	
	#('2r1ez') do: [:each |
		self fail: each rule: #number.]! !

!PPSmalltalkNumberGrammarTests methodsFor: 'test - helper' stamp: 'fbs 9/3/2011 21:54'!
testStrToRadixConvertsStringsToNumbers
	2 to: 26 do: [:i | | radix |
		radix := i asString.
		self assert: i equals: (parser strToRadix: radix at: 0)].
		
	"These are invalid radix indicators."
	#('1' '37' '' ' ' 'aa' 'r') do: [:each |
		(parser strToRadix: each at: 0) isPetitFailure].! !

PPCompositeParserTest subclass: #PPSmalltalkNumberParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitSmalltalk-Tests'!

!PPSmalltalkNumberParserTest methodsFor: 'accessing' stamp: 'fbs 9/4/2011 23:02'!
parserClass
	^ PPSmalltalkNumberParser! !

!PPSmalltalkNumberParserTest methodsFor: 'test - integers' stamp: 'fbs 9/8/2011 12:21'!
testParseIntegers
	self assert: 1 equals: (parser parse: '1').
	self assert: 0 equals: (parser parse: '0').
	self assert: -1 equals: (parser parse: '-1').
	self assert: 9876543210 equals: (parser parse: '9876543210').
	self assert: 987654321098765432109876543210 equals: (parser parse: '987654321098765432109876543210').
	self assert: 1e10 equals: (parser parse: '1e10').
	
	self assert: 4r1 equals: (parser parse: '4r1').
	self assert: 4r0 equals: (parser parse: '4r0').
	self assert: -4r1 equals: (parser parse: '-4r1').
	self assert: 4r-1 equals: (parser parse: '4r-1').
	self assert: 11r9876543210 equals: (parser parse: '11r9876543210').
	self assert: 16r987654321098765432109876543210abcdef equals: (parser parse: '16r987654321098765432109876543210abcdef').
	self assert: 4r1e10 equals: (parser parse: '4r1e10').! !

PPTokenParser subclass: #PPSmalltalkTokenParser
	instanceVariableNames: ''
	classVariableNames: 'SeparatorPredicate'
	poolDictionaries: ''
	category: 'PetitSmalltalk-Core'!

!PPSmalltalkTokenParser commentStamp: 'lr 11/29/2009 09:59' prior: 0!
A parser that knows how to skip comments and whitespace in Smalltalk and how to instantiate tokens.!

!PPSmalltalkTokenParser class methodsFor: 'initialization' stamp: 'lr 9/5/2010 23:42'!
initialize
	SeparatorPredicate := PPCharSetPredicate on: [ :char | char isSeparator ]! !

!PPSmalltalkTokenParser methodsFor: 'private' stamp: 'lr 4/6/2010 20:13'!
defaultTokenClass
	^ PPSmalltalkToken! !

!PPSmalltalkTokenParser methodsFor: 'parsing' stamp: 'lr 10/5/2010 16:30'!
parseComments: anArray on: aStream
	| start comments |
	comments := anArray.
	[ [ aStream atEnd not and: [ SeparatorPredicate value: aStream uncheckedPeek ] ]
		whileTrue: [ aStream next ].
	 aStream atEnd not and: [ aStream uncheckedPeek = $" ] ] whileTrue: [
		aStream next.
		start := aStream position.
		aStream upTo: $".
		comments := comments copyWith: (start to: aStream position) ].
	^ comments! !

!PPSmalltalkTokenParser methodsFor: 'parsing' stamp: 'lr 4/6/2010 20:12'!
parseOn: aStream
	| start comments token |
	start := aStream position.
	comments := self
		parseComments: #()
		on: aStream.
	token := super parseOn: aStream.
	token isPetitFailure ifTrue: [
		aStream position: start.
		^ token ].
	comments := self
		parseComments: comments
		on: aStream.
	^ token comments: comments! !
PPSmalltalkNumberMaker initialize!
PPSmalltalkTokenParser initialize!
